DECLARE SUB GetPellet ()
DECLARE SUB DrawGhost (i%)
DECLARE SUB MakeMask (MaskAry&(), x1%, y1%, x2%, y2%)
DECLARE SUB AddTrail (x1 AS INTEGER, y1 AS INTEGER, i AS INTEGER)
DECLARE SUB AddMove (x1%, y1%)
DECLARE SUB Pause ()
DECLARE SUB stopClock (j%)
DECLARE SUB GhostThink (i AS INTEGER)
DECLARE SUB SetStage (S1$, S2$)
DECLARE SUB NextFruit ()
DECLARE SUB MovePrize ()
DECLARE SUB Points (num%)
DECLARE SUB EyesDinky ()
DECLARE SUB EyesSue ()
DECLARE SUB EyesPinky ()
DECLARE SUB Remain (gx%, gy%, ax%, ay%)
DECLARE SUB DeadPac ()
DECLARE SUB MoveEyes (i AS INTEGER)
DECLARE SUB DifChange ()
DECLARE SUB FigureScreen ()
DECLARE SUB DrawGhosts ()
DECLARE SUB PutFruit ()
DECLARE SUB InkyThink ()
DECLARE SUB GhostFollow (i AS INTEGER)
DECLARE SUB MoveGhost (i AS INTEGER)
DECLARE SUB MoveSue ()
DECLARE SUB Biten ()
DECLARE SUB SueThink ()
DECLARE SUB SmartSue ()
DECLARE SUB DinkyThink ()
DECLARE SUB SmartDinky ()
DECLARE SUB MoveDinky ()
DECLARE SUB Codes ()
DECLARE SUB MoveGhosts ()
DECLARE SUB PelletCounter ()
DECLARE SUB HiScore ()
DECLARE SUB Eaten (i AS INTEGER, Status%)
DECLARE SUB Lost ()
DECLARE SUB Won ()
DECLARE SUB SmartPinky ()
DECLARE SUB NextStage ()
DECLARE SUB PinkyThink ()
DECLARE SUB MainOperations ()
DECLARE SUB MovePac ()
DECLARE SUB MovePinky ()
DECLARE SUB Load ()
DECLARE SUB DrawPacMan ()
DECLARE SUB MoveInit (i AS INTEGER)
DECLARE SUB PrintAttr (Attrib%)

REM Janurary 2, 1996-Feburary 29, 1997 (Originally)
REM Jimmy Reumuth
REM PacMan

ON ERROR GOTO ErrorKiller

SCREEN 12

CONST ScrX = 112, ScrY = 32, ScrLen = 416, RowAboveScr% = ScrY / 16 - .5
CONST CenterX% = ScrX + ScrLen / 2, CenterY% = ScrY + ScrLen / 2

CONST Blink = 1200, Pi = 3.141592654#, DotColor = 15 'Blink% = 153
CONST false = 0, true = NOT false 'true = -1
CONST MaxInt = 32767

DEF FNSize& (dx%, dy%) = INT(dx% / 8 + 1) * (dy% + 1)
   
DIM SHARED x%, y%, AddX%, AddY%, Score&, Pellets%, Stage%, Lives%, GhostCount%
DIM SHARED ControlGhost%
DIM SHARED AddX1%, AddY1%, SlowGhost!, path$, GhostLimit%

TYPE GhostType
  x AS INTEGER
  y AS INTEGER
  LastX AS INTEGER
  LastY AS INTEGER
  AddX AS INTEGER
  AddY AS INTEGER
  AddX1 AS INTEGER
  AddY1 AS INTEGER
  Status AS INTEGER
  ThinkWith AS INTEGER
  Trail AS INTEGER
  Delay AS SINGLE
END TYPE
DIM LastStatus%(1 TO 4)

CONST Init = 0, Think = 1, Follow = 2 'enums for GhostType.ThinkWith
CONST Normal = 0, Blue = 1, Eyes = 2 'enums for GhostType.Status
REM enums for SUB PrintAttr
CONST TheScore = 0, TheLives = 1, TheStage = 2, TheRank = 3
REM enums for Difficulty%; Normal has already been defined as 0 for Status
CONST Easy = 1, Hard = 2
               
DIM Ghost(1 TO 4) AS GhostType
REM 1 Pinky
REM 2 Inky
REM 3 Dinky
REM 4 Sue

DIM HiScores&(1 TO 20)
DIM HiScores$(1 TO 21)

DIM Scrn%(26, 26)
CONST Empty = 0, Pellet = 1, PowerPellet = 2, Wall = 3 'enums for Scrn%

DIM Movement%(26, 26)
DIM EyeTrail%(1 TO 4, 26, 26)

REM Pacman
CONST ArySize = 120 'for 28 x 28 pixel sprites
DIM pac1&(ArySize)
DIM pacd1&(ArySize)
DIM pacu1&(ArySize)
DIM pacl1&(ArySize)
DIM pacr1&(ArySize)
DIM pacd2&(ArySize)
DIM pacu2&(ArySize)
DIM pacl2&(ArySize)
DIM pacr2&(ArySize)
DIM pacd3&(ArySize)
DIM pacu3&(ArySize)
DIM pacl3&(ArySize)
DIM pacr3&(ArySize)
DIM PacMask&(ArySize)

REM Ghosts to be used with the GET and PUT statements.
DIM InkySprite&(ArySize)
DIM SueSprite&(ArySize)
DIM DinkySprite&(ArySize)
DIM PinkySprite&(ArySize)
DIM BlueGhost&(ArySize)
DIM WhiteGhost&(ArySize)
DIM GhostMask&(ArySize)

DIM EyesSprite&(20)

DIM Prize&(ArySize)
DIM PrizeMask&(ArySize)

REM Functions to calculate where lines for PacMan's mouth should be drawn.
DEF FNcosine (x) = COS(x * Pi) * 14
DEF FNsine (x) = SIN(x * Pi) * 14

DEF FNGetBlueGhostColor%
  STATIC LastColor%
  IF Difficulty% = Hard THEN
    DO
      GhostColor% = INT(RND * 16)
    LOOP UNTIL GhostColor% <> 9 AND GhostColor% <> 11 AND GhostColor% <> LastColor%
  ELSEIF Difficulty% = Normal THEN
    GhostColor% = 9
  ELSEIF Difficulty% = Easy THEN
    GhostColor% = 11
  END IF
  LastColor% = GhostColor%
  FNGetBlueGhostColor% = GhostColor%
END DEF

DEF FNGetPowColor%
  STATIC LastPowColor%
  DO
    TempPowColor% = INT(RND * 7)
  LOOP UNTIL TempPowColor% <> LastPowColor%
  LastPowColor% = TempPowColor%
  FNGetPowColor% = TempPowColor%
END DEF

DEF FNMovePac
  STATIC PacCount AS SINGLE
  IF TIMER - PacCount > .03 THEN
    FNMovePac = true
    PacCount = TIMER
  END IF
END DEF

DEF FNFifty% (num1 AS INTEGER, num2 AS INTEGER)
  REM This function has a fifty percent chance of returning the first value
  REM and a fifty % change of returning the second value.
  IF INT(RND * 2) MOD 2 = 0 THEN
    FNFifty% = num1
  ELSE
    FNFifty% = num2
  END IF
END DEF

REM This function return true then false NumOfBlinks% number of times if cal-
REM led continuously until GhostCount% = GhostLimit%.  Blink is a CONST that
REM determines how long the blink will last.
DEF FNBlink% (NumOfBlinks AS INTEGER) = GhostCount% > GhostLimit% - Blink AND GhostCount% MOD Blink / NumOfBlinks < Blink / (NumOfBlinks * 2)
'DIM LastBlink%(1 TO 4)
'DEF FNBlink% (NumOfBlinks AS INTEGER, i AS INTEGER)
'  NewBlink% = GhostCount% > GhostLimit% - Blink AND GhostCount% MOD Blink / NumOfBlinks < Blink / (NumOfBlinks * 2)
'  IF LastBlink%(i) <> NewBlink% THEN
'    PUT (Ghost(i).x, Ghost(i).y), GhostMask&, AND
'    LastBlink%(i) = NewBlink%
'  END IF
'  FNBlink% = NewBlink%
'END DEF

REM FNAtEdge% returns true is the coordinates are at the edges or the screen.
REM (x1% - ScrX) MOD ScrLen = 0 when x1% = ScrX or ScrX + ScrLen.  2 * ScrX +
REM ScrLen - x1% = ScrX if x1% = ScrX + ScrLenX;  it = ScrX + ScrLen if x1% =
REM ScrX.  This function is often used to tell when something has entered a
REM tunnel.
CONST DeadEnd = 1, GoThruX = 2, GoThruY = 3
DEF FNAtEdge% (x1%, y1%, AddX2%, AddY2%)
  IF (x1% - ScrX) MOD ScrLen = 0 THEN
    REM If PacMan goes through the tunnel his new position will be 2 * ScrX
    REM + ScrLen - x1% + AddX2%.  To test if that position is not a tunnel, it
    REM is substituted into x1% in the Scrn% array as x1% and checks for an
    REM obstruction.
    IF Scrn%((ScrX + ScrLen - x1% + AddX2%) / 16, (y1% - ScrY) / 16) = Wall THEN
      FNAtEdge% = DeadEnd
    ELSE
      FNAtEdge% = GoThruX
    END IF
  END IF
  IF (y1% - ScrY) MOD ScrLen = 0 THEN
    IF Scrn%((x1% - ScrX) / 16, (ScrY + ScrLen - y1% + AddY2%) / 16) = Wall THEN
      FNAtEdge% = DeadEnd
    ELSE
      FNAtEdge% = GoThruY
    END IF
  END IF
END DEF

REM Function that takes the STR$ of a number and takes out the leading space.
DEF FNStr$ (num&) = LTRIM$(STR$(num&))

REM The FNText% functions return the text mode equivatent of graphical
REM coordinates.
DEF FNTextX% (x1%) = INT(x1% / 8) + 1
DEF FNTextY% (y1%) = INT(y1% / 16) + 1

REM Returns the inittial x or y position of a specified ghost.
DEF FNInitPos% (dem$, i%)
  IF LCASE$(dem$) = "x" THEN
    SELECT CASE i%
      CASE 1: FNInitPos% = CenterX - 47
      CASE 2: FNInitPos% = CenterX - 15
      CASE 3: FNInitPos% = CenterX + 17
      CASE 4: FNInitPos% = CenterX - 15
    END SELECT
  ELSEIF LCASE$(dem$) = "y" THEN
    SELECT CASE i%
      CASE 1: FNInitPos% = CenterY - 15
      CASE 2: FNInitPos% = CenterY - 63
      CASE 3: FNInitPos% = CenterY - 15
      CASE 4: FNInitPos% = CenterY - 15
    END SELECT
  END IF
END DEF

REM The Start label is used in restarting the game.  Everything above this
REM label does not need to be reinitalized anytime during the game.
Start:

RANDOMIZE TIMER

x% = CenterX: y% = CenterY + 48
HoldX% = x%: HoldY% = y%

FOR i% = 1 TO 4
  Ghost(i%).x = FNInitPos%("x", i%)
  Ghost(i%).y = FNInitPos%("y", i%)
  Ghost(i%).Status = Normal
  Ghost(i%).Trail = MaxInt
  Ghost(i%).ThinkWith = Init
NEXT

PrizeX% = ScrX + ScrLen + 1
PrizeY% = ScrY + ScrLen - 28
Lives% = 3
Stage% = 1
ControlGhost% = 0
PowerOn% = false
RankPlace% = 20

IF Ik$ = "" THEN
  Load
ELSE
  CLS
  Score& = 0
  LastScore& = Score&
  Pellets% = 0
  PUT (Ghost(1).x, Ghost(1).y), PinkySprite&
  PUT (Ghost(3).x, Ghost(3).y), DinkySprite&
  PUT (Ghost(4).x, Ghost(4).y), SueSprite&
  PUT (Ghost(2).x, Ghost(2).y), InkySprite&
  Fruit$ = ""
  Ik$ = ""
END IF

PrintAttr (TheLives)
PrintAttr (TheScore)
CALL SetStage("Scr1_1.GRH", "Scr1_2.GRH")

DO UNTIL Ik$ = CHR$(27) OR LCASE$(Ik$) = "restart"
 Ik$ = INKEY$
  SELECT CASE Ik$
    CASE IS = CHR$(0) + "H", "8"  'Up
      AddY1% = -16: AddX1% = 0
     
    CASE IS = CHR$(0) + "P", "2" 'Down
      AddY1% = 16: AddX1% = 0
     
    CASE IS = CHR$(0) + "M", "6" 'Right
      AddX1% = 16: AddY1% = 0
     
    CASE IS = CHR$(0) + "K", "4" 'Left
      AddX1% = -16: AddY1% = 0
     
   CASE IS = "a", "A"
      IF ControlGhost% > 0 THEN Ghost(ControlGhost%).AddX1 = -16: Ghost(ControlGhost%).AddY1 = 0

      'Ghost(1).AddX1 = -16: Ghost(1).AddY1 = 0
      'Ghost(3).AddX1 = -16: Ghost(3).AddY1 = 0
      'Ghost(4).AddX1 = -16: Ghost(4).AddY1 = 0
      'Ghost(2).AddX1 = -16: Ghost(2).AddY1 = 0
   
    CASE IS = "s", "S"
      IF ControlGhost% > 0 THEN Ghost(ControlGhost%).AddX1 = 0: Ghost(ControlGhost%).AddY1 = 16
     
      'Ghost(1).AddX1 = 0: Ghost(1).AddY1 = 16
      'Ghost(3).AddX1 = 0: Ghost(3).AddY1 = 16
      'Ghost(4).AddX1 = 0: Ghost(4).AddY1 = 16
      'Ghost(2).AddX1 = 0: Ghost(2).AddY1 = 16
   
    CASE IS = "w", "W"
      IF ControlGhost% > 0 THEN Ghost(ControlGhost%).AddX1 = 0: Ghost(ControlGhost%).AddY1 = -16
     
      'Ghost(1).AddX1 = 0: Ghost(1).AddY1 = -16
      'Ghost(3).AddX1 = 0: Ghost(3).AddY1 = -16
      'Ghost(4).AddX1 = 0: Ghost(4).AddY1 = -16
      'Ghost(2).AddX1 = 0: Ghost(2).AddY1 = -16
   
    CASE IS = "d", "D"
      IF ControlGhost% > 0 THEN Ghost(ControlGhost%).AddX1 = 16: Ghost(ControlGhost%).AddY1 = 0
     
      'Ghost(1).AddX1 = 16: Ghost(1).AddY1 = 0
      'Ghost(3).AddX1 = 16: Ghost(3).AddY1 = 0
      'Ghost(4).AddX1 = 16: Ghost(4).AddY1 = 0
      'Ghost(2).AddX1 = 16: Ghost(2).AddY1 = 0
   
    CASE IS = CHR$(0) + ";" 'F1
      SELECT CASE ControlGhost%
       CASE IS = 0
        ControlGhost% = 1
        Ghost(1).AddX = 0: Ghost(1).AddY = 0

       CASE IS = 1
        ControlGhost% = 3
        Ghost(3).AddX = 0: Ghost(3).AddY = 0

       CASE IS = 3
        ControlGhost% = 4
     
       CASE IS = 4
        ControlGhost% = 2
      
       CASE IS = 2
        ControlGhost% = 0
      END SELECT
   
    CASE IS = "l", "L"
      IF Secret% = 0 THEN Codes

    CASE IS = CHR$(0) + "<" 'F2
      Pause

    CASE IS = CHR$(0) + "=" 'F3
      IF Secret% = 0 AND Stage% < max% THEN
        NoPrize% = true
        NextStage
      END IF

    CASE IS = CHR$(0) + ">" 'F4
      IF Secret% = 0 THEN DifChange
   
    CASE IS = CHR$(0) + CHR$(63) 'F5
      IF Stage% < max% THEN
        NoPrize% = true
        Stage% = max% - 1
        NextStage
      END IF

    CASE IS = CHR$(0) + CHR$(64) 'F6
      REM Prints out how many pellets need to be eaten before the Fruit-Pirze
      REM appears.
      stopClock (-1)
      LOCATE 1, 1
      PRINT Pellets% - GetFruit%
      SLEEP
      LOCATE 1, 1
      PRINT "    "
      stopClock (1)

    CASE IS = CHR$(0) + CHR$(65) 'F7
      Mute% = NOT Mute%

    CASE IS = CHR$(0) + CHR$(66) 'F8

  END SELECT

  MainOperations
LOOP

OPEN path$ + "max" FOR OUTPUT AS #1
  PRINT #1, max%
  PRINT #1, Mute%
  PRINT #1, Difficulty%
CLOSE #1

IF LCASE$(Ik$) = "restart" THEN GOTO Start

SYSTEM

HiScoreError:
  CLOSE #1
  OPEN path$ + "HiScores" FOR OUTPUT AS #1
    FOR Scores& = 20 TO 1 STEP -1
      WRITE #1, Scores& * 10000
      SELECT CASE Scores&
        CASE 20: WRITE #1, "Jimmy Reumuth"
        CASE 19: WRITE #1, "$nake"
        CASE 18: WRITE #1, "Joseph"
        CASE 17: WRITE #1, "Tha' Man"
        CASE ELSE: WRITE #1, "Jimmy"
      END SELECT
    NEXT
    WRITE #1, "Losfer Words"
  CLOSE #1
  SHELL "attrib +h " + path$ + "HiScores"

  OPEN path$ + "HiScores" FOR INPUT AS #1
  RESUME NEXT

PacPathError:
  CLS
  LOCATE 1, 1
  Out$ = "Running Setup..."
  PRINT Out$
  REM This routine finds the correct path and writes it to the "PacPath" file.

  SHELL "cd\"
  SHELL "dir/s Scr1_1.grh > tempFile"

  OPEN "tempFile" FOR INPUT AS #2
    FOR i% = 1 TO 5
      INPUT #2, path$
    NEXT
  CLOSE #2
 
  path$ = RIGHT$(path$, LEN(path$) - 13)
  path$ = path$ + "\"
  SHELL "del tempFile"

  IF RIGHT$(path$, 3) = ":\\" THEN
    PRINT "Cannot find first stage on this drive."
    PRINT "You must have at least one stage to run PacMan,"
    PRINT "PacMan must be run from the drive on which its graphic files exist,"
    PRINT "and its graphics files cannot be installed in the root directory."
    PRINT "If PacMan was setup in the root directory, run UnInstal.EXE,"
    PRINT "make a directory to unzip Pac10.ZIP to and rerun Pac10.BAS."
    SLEEP
    SYSTEM
  END IF

  OPEN "PacPath" FOR OUTPUT AS #2
    WRITE #2, path$
  CLOSE #2
 
  SHELL "attrib +h PacPath"
 
  LOCATE 1, 1
  PRINT SPC(LEN(Out$));
  RESUME

MaxError:
  REM Writes the maximum stage to which one can warp, mute status and
  REM a difficulty constant to a file.
  IF max% = 0 THEN max% = 1
  IF slowing! = 0 THEN slowing! = .18
  CLOSE #1
  OPEN path$ + "max" FOR OUTPUT AS #2
    PRINT #2, max%
    PRINT #2, Mute%
    PRINT #2, Difficulty%
  CLOSE #2
  SHELL "attrib +h " + path$ + "max"
  RESUME NEXT

FruitError:
  REM You can try things other than a stage not bearing fruit (Fruit$ = "f")
  REM for a FruitError
  Fruit$ = "f"
  'BLOAD path$ + "Prize" + FNStr$(rnd*55) + ".GRH", VARPTR(Prize&(0))
  'BLOAD path$ + "Prize1.GRH", VARPTR(Prize&(0))
  RESUME NEXT

ErrorKiller:
 SELECT CASE ERR
   CASE 53
     REM 53 is the errorcode for file not found, so if the next file to be
     REM found is not there then the player has completed all the stages.
     IF Stage% = 1 THEN
       PRINT "Cannot find first stage in this directory."
       PRINT "You must have at least one stage to run PacMan,"
       PRINT "and you must be in the directory of that stage."
       'PRINT "PacMan must be run from the drive on which its graphic files exist,"
       'PRINT "and its graphics files cannot be installed in the root directory."
       'PRINT "If PacMan was setup in the root directory, run UnInstal.EXE,"
       'PRINT "make a directory to unzip Pac10.ZIP to and rerun Pac10.BAS."
       SLEEP
       SYSTEM
     ELSE
       Won
     END IF
    
   'CASE 76, 62, 52
   '  REM 76, 62 and 52 are the Errorcodes for path not found, input past
   '  REM end of file, and bad file name or number, respectavely.
   '  STOP
   '  RESUME
  
   CASE ELSE
     REM This causes the program to skip any other type of error which will
     REM at least keep the program from crashing and will possibly still
     REM allow it to run fine.
     STOP: RESUME
     'RESUME NEXT
 END SELECT

SUB AddMove (x1%, y1%)
SHARED PlaceNum%, Movement%()
REM This SUB gives every new place PacMan steps onto a number so the ghosts
REM can follow him in the GhostFollow SUB
 
'IF Movement%((x1% - ScrX) / 16, (y1% - ScrY) / 16) = 0 THEN
  PlaceNum% = PlaceNum% + 1
  Movement%((x1% - ScrX) / 16, (y1% - ScrY) / 16) = PlaceNum%
'END IF

END SUB

SUB AddTrail (x1 AS INTEGER, y1 AS INTEGER, i AS INTEGER)
SHARED EyeTrail%(), Ghost() AS GhostType
IF Ghost(i).Status <> Eyes AND EyeTrail%(i, (x1 - (ScrX - 15)) / 16, (y1 - (ScrY - 15)) / 16) < Ghost(i).Trail THEN
  EyeTrail%(i, (x1 - (ScrX - 15)) / 16, (y1 - (ScrY - 15)) / 16) = Ghost(i).Trail
  Ghost(i).Trail = Ghost(i).Trail - 1
END IF

END SUB

SUB Biten
SHARED Ghost() AS GhostType

REM Checks to see if PacMan ran into a ghost and call SUB Eaten if he did.

REM The reason why "IF Ghost(i%).Status <> Eyes" is written out twice is
REM because Ghost(1).Status can change into Eyes in SUB Eaten, so reading the
REM extra IF statement very often saves the computer from going through a FOR
REM loop and calling a SUB twice half the time the ghost gets eaten.

FOR i% = 1 TO 4
  IF Ghost(i%).Status <> Eyes THEN
    FOR x6% = Ghost(i%).x - 1 TO Ghost(i%).x + 31 STEP 16
      IF x% = x6% AND Ghost(i%).y + 15 = y% THEN
        CALL Eaten(i%, (Ghost(i%).Status))
        EXIT FOR
      END IF
    NEXT
  END IF
  IF Ghost(i%).Status <> Eyes THEN
    FOR y6% = Ghost(i%).y - 1 TO Ghost(i%).y + 31 STEP 32
      IF Ghost(i%).x + 15 = x% AND y% = y6% THEN
        CALL Eaten(i%, (Ghost(i%).Status))
        EXIT FOR
      END IF
    NEXT
  END IF
NEXT

END SUB

SUB Codes
SHARED max%, NoPrize%
stopClock (-1)

REM Sub with codes that can be inputted during the game to allow warping to
REM any level or giving the player an extra life.
REM Level changing is done by pressing "l" which brings the program here, then
REM typeing "evel" followed by the stage number.
REM Life changing is done by typing the word "lives."

in$ = INPUT$(4)
IF LCASE$(in$) = "ives" THEN
  Lives% = Lives% + 1
  PrintAttr (TheLives)
END IF
   
IF LCASE$(in$) = "evel" THEN
  LOCATE 1, 1
  INPUT "What Stage? ", Stage$
 
  REM Erases the "What Stage? " and anything inputted Call Remaining on the screen.
  LOCATE 1, 1: PRINT SPC(LEN(Stage$) + 12);

  IF LEN(Stage$) >= 3 THEN PrintAttr (TheRank)
 
  s% = INT(VAL(Stage$) + .5)
 
  IF s% > 0 AND s% <= max% THEN
    REM deletes the printout in the upper middle of the screen of the stage
    REM the player is on.
    WrittenStageLen% = LEN("Stage" + STR$(Stage%))
    LOCATE RowAboveScr, FNTextX%(CenterX) - WrittenStageLen% / 2
    PRINT SPC(WrittenStageLen%);
    Stage% = s% - 1
    NoPrize% = true
    stopClock (1)
    NextStage
  END IF
ELSE
  stopClock (1)
END IF

END SUB

SUB DeadPac
SHARED Fruit$, LastFx%, LastFy%, SecretStage%, Mute%, UnSec%, PowerOn%
SHARED Secret%, Movement%(), EyeTrail%(), Scrn%(), Ghost() AS GhostType
SHARED InkySprite&(), DinkySprite&(), SueSprite&(), PinkySprite&(), pacr2&()

  CONST Deg = 3.141592654# / 180
  REM The for loop makes pacman shrivel when he dies.-------------------------

  FOR Angle% = 93 TO 270
    IF Angle% MOD 15 = 0 AND Mute% = false THEN SOUND 468 - Angle%, .75

    LINE (x% - 14, y% - 15)-(x% + 14, y% + 14), 0, BF
    edge# = 180 * Deg - (Angle% * Deg)
    IF edge# < 0 THEN edge# = 360 * Deg + edge#
 
    CIRCLE (x%, y%), 14, 14, Angle% * Deg, edge#
   
      XCord! = x% + 14 * SIN((Angle% + 90) * Deg)
      YCord! = y% + 14 * COS((Angle% + 90) * Deg)
      LINE (x%, y%)-(XCord!, YCord!), 14
   
      XCord! = x% + 14 * SIN(edge# + 90 * Deg)
      YCord! = y% + 14 * COS(edge# + 90 * Deg)
      LINE (x%, y%)-(XCord!, YCord!), 14
 
      PAINT (x%, y% + 13), 14
      FOR B& = 1 TO INT(300000 * Delay!): NEXT
  NEXT
  REM This line erases a verticle line going down from the center of PacMan
  REM that the above loop leaves.
  LINE (x%, y%)-(x%, y% + 14), 0
  SLEEP 1
  '---------------------------------------------------------------------------
  Lives% = Lives% - 1
  PrintAttr (TheLives)
  IF Secret% <> 0 THEN
    UnSec% = true
    Stage% = Stage% - 1
    NextStage
  END IF
  IF Fruit$ = "t" OR Fruit$ = "l" THEN
    LINE (LastFx% - 13, LastFy% - 14)-(LastFx% + 15, LastFy% + 14), 0, BF
    CALL Remain(LastFx% - 15, LastFy% - 15, (AddFx%), (AddFy%))
  END IF
  Fruit$ = "f"
  PowerOn% = true: GhostCount% = GhostLimit%
  Ghost(1).Delay = TIMER + 4
  Ghost(2).Delay = TIMER + 1
  Ghost(3).Delay = TIMER + 3
  Ghost(4).Delay = TIMER + 2
  PaceNum% = 0
  ERASE Movement%
  x% = CenterX: y% = CenterY + 48
  HoldX% = x%: HoldY% = y%
  AddX1% = 0: AddY1% = 0
  AddX% = 0: AddY% = 0
  IF Scrn%(13, 16) = 4 THEN Scrn%(13, 16) = 5
  '===========================================================================
  REM Effects on ghosts of PacMan dieing.
  ERASE EyeTrail%
 
  FOR i% = 1 TO 4
    Ghost(i%).Status = Normal
    LINE (Ghost(i%).x, Ghost(i%).y)-(Ghost(i%).x + 28, Ghost(i%).y + 28), 0, BF
    CALL Remain(Ghost(i%).x, Ghost(i%).y, 16, 16)
    Ghost(i%).x = FNInitPos%("x", i%)
    Ghost(i%).y = FNInitPos%("y", i%)
    Ghost(i%).LastX = Ghost(i%).x: Ghost(i%).LastY = Ghost(i%).y
    Ghost(i%).Trail = MaxInt
    Ghost(i%).ThinkWith = Init
  NEXT
   
  PUT (Ghost(1).x, Ghost(1).y), PinkySprite&, OR
  PUT (Ghost(2).x, Ghost(2).y), InkySprite&, OR
  PUT (Ghost(3).x, Ghost(3).y), DinkySprite&, OR
  PUT (Ghost(4).x, Ghost(4).y), SueSprite&, OR

  PUT (x% - 14, y% - 14), pacr2&, PSET
END SUB

SUB DifChange
REM This SUB is called when switching between difficulty levels.
SHARED slowing!, Free&, Difficulty%, PinkySprite&(), BlueGhost&(), Scrn%()
stopClock (-1)

  SELECT CASE slowing!
    CASE IS = .12
     slowing! = .24
     LOCATE 2, 1
     PRINT "Easy  "
     Difficulty% = Easy
     Free& = 30000

  CASE IS = .24
     slowing! = .18
     LOCATE 2, 1
     PRINT "Normal"
     Difficulty% = Normal
     Free& = 50000

  CASE IS = .18
     slowing! = .12
     LOCATE 2, 1
     PRINT "Hard  "
     Difficulty% = Hard
     Free& = 70000

  END SELECT
 
  SlowGhost! = slowing! - (Stage% * .0007)
  SLEEP
  REM Print spaces over the easy, normal or hard.
  LOCATE 2, 1
  PRINT "      "

'----------------------------------------------------------------------------
IF Difficulty% = Normal OR Difficulty% = Easy THEN
  REM redraws the dots
  FOR y5% = ScrY + 16 TO ScrY + ScrLen - 16 STEP 16
  FOR x5% = ScrX + 16 TO ScrX + ScrLen - 16 STEP 16
     IF Scrn%((x5% - ScrX) / 16, (y5% - ScrY) / 16) = Pellet THEN
       LINE (x5% - 2, y5% - 2)-(x5% + 4, y5% + 4), 0, BF
       IF Difficulty% <> Easy THEN
         LINE (x5% - 2, y5% - 3)-(x5% + 4, y5% + 4), 0, BF
         CIRCLE (x5% + 1, y5% + 1), 3, DotColor
         PAINT (x5% + 1, y5% + 1), DotColor
       ELSE
         LINE (x5% - 2, y5% - 2)-(x5% + 2, y5% + 2), DotColor, BF
       END IF
     END IF
  NEXT: NEXT
END IF

c% = FNGetBlueGhostColor%

IF Difficulty% = Hard OR (Difficulty% = Easy AND c3% <> 11) OR (Difficulty% = Normal AND c3% <> 9) THEN
  REM changes the blue ghost color to c%
 
  LINE (FNInitPos%("x", 1), FNInitPos%("y", 1))-(FNInitPos%("x", 1) + 28, FNInitPos%("y", 1) + 28), 0, BF
  PUT (FNInitPos%("x", 1), FNInitPos%("y", 1)), PinkySprite&
  REM The Blue-Ghost(When PacMan has a power pellet).
 
  FOR Gx1% = FNInitPos%("x", 1) TO FNInitPos%("x", 1) + 28
    FOR Gy1% = FNInitPos%("y", 1) TO FNInitPos%("y", 1) + 28
      IF POINT(Gx1%, Gy1%) = 13 THEN PSET (Gx1%, Gy1%), c%
    NEXT
  NEXT
 
  GET (FNInitPos%("x", 1), FNInitPos%("y", 1))-(FNInitPos%("x", 1) + 28, FNInitPos%("y", 1) + 28), BlueGhost&
  LINE (FNInitPos%("x", 1), FNInitPos%("y", 1))-(FNInitPos%("x", 1) + 28, FNInitPos%("y", 1) + 28), 0, BF
END IF

stopClock (1)
END SUB

SUB DrawGhost (i%)
SHARED EyesSprite&(), InkySprite&(), DinkySprite&(), SueSprite&()
SHARED PinkySprite&(), WhiteGhost&(), BlueGhost&(), GhostMask&()
SHARED LastStatus%(), Ghost() AS GhostType

IF Ghost(i%).Status = Blue AND FNBlink%(3) = true THEN
  REM 4 is for white (when the ghost blinks)
  DrawStatus% = 4
ELSE
  DrawStatus% = Ghost(i%).Status
END IF

IF Ghost(i%).LastX <> Ghost(i%).x OR Ghost(i%).LastY <> Ghost(i%).y OR DrawStatus% <> LastStatus%(i%) THEN

  REM erases the last sprite
  'SELECT CASE LastStatus%(i%)
  '  CASE Eyes: PUT (Ghost(i%).LastX + 10, Ghost(i%).LastY + 5), EyesSprite&, XOR
  '  CASE Blue: PUT (Ghost(i%).LastX, Ghost(i%).LastY), BlueGhost&, XOR
  '  CASE 4: PUT (Ghost(i%).LastX, Ghost(i%).LastY), WhiteGhost&, XOR
  '  CASE Normal
  '    SELECT CASE i%
  '      CASE 1: PUT (Ghost(i%).LastX, Ghost(i%).LastY), PinkySprite&, XOR
  '      CASE 2: PUT (Ghost(i%).LastX, Ghost(i%).LastY), InkySprite&, XOR
  '      CASE 3: PUT (Ghost(i%).LastX, Ghost(i%).LastY), DinkySprite&, XOR
  '      CASE 4: PUT (Ghost(i%).LastX, Ghost(i%).LastY), SueSprite&, XOR
  '    END SELECT
  'END SELECT

  IF DrawStatus% = Eyes THEN
    LINE (Ghost(i%).LastX + 10, Ghost(i%).LastY + 5)-(Ghost(i%).LastX + 14, Ghost(i%).LastY + 12), 0, BF
    LINE (Ghost(i%).LastX + 18, Ghost(i%).LastY + 5)-(Ghost(i%).LastX + 22, Ghost(i%).LastY + 12), 0, BF
  ELSE
    PUT (Ghost(i%).LastX, Ghost(i%).LastY), GhostMask&, AND
    CALL Remain(Ghost(i%).LastX, Ghost(i%).LastY, Ghost(i%).AddX, Ghost(i%).AddY)
    PUT (Ghost(i%).x, Ghost(i%).y), GhostMask&, AND
  END IF

  LastStatus%(i%) = DrawStatus%
END IF

  REM puts the new sprite
  SELECT CASE DrawStatus%
    CASE Eyes: PUT (Ghost(i%).x + 10, Ghost(i%).y + 5), EyesSprite&, OR
    CASE 4: PUT (Ghost(i%).x, Ghost(i%).y), WhiteGhost&, OR
    CASE Blue: PUT (Ghost(i%).x, Ghost(i%).y), BlueGhost&, OR
    CASE Normal
      SELECT CASE i%
        CASE 1: PUT (Ghost(i%).x, Ghost(i%).y), PinkySprite&, OR
        CASE 2: PUT (Ghost(i%).x, Ghost(i%).y), InkySprite&, OR
        CASE 3: PUT (Ghost(i%).x, Ghost(i%).y), DinkySprite&, OR
        CASE 4: PUT (Ghost(i%).x, Ghost(i%).y), SueSprite&, OR
      END SELECT
  END SELECT


END SUB

SUB DrawGhosts
SHARED EyesSprite&(), InkySprite&(), DinkySprite&(), SueSprite&(), GhostMask&()
SHARED PinkySprite&(), WhiteGhost&(), BlueGhost&(), Ghost() AS GhostType

DIM i AS INTEGER

REM Draws Ghosts.
FOR i = 1 TO 4
  'IF FNChange%(i) = false THEN
  '  i = i + 1
  '  IF i = 5 THEN EXIT FOR
  'END IF
  SELECT CASE Ghost(i).Status
    CASE Eyes
      PUT (Ghost(i).x + 10, Ghost(i).y + 5), EyesSprite&, OR
    CASE Blue
      IF FNBlink%(3) THEN
        PUT (Ghost(i).x, Ghost(i).y), WhiteGhost&, OR
      ELSE
        PUT (Ghost(i).x, Ghost(i).y), BlueGhost&, PSET
      END IF
    CASE Normal
      SELECT CASE i
        CASE 1: PUT (Ghost(i).x, Ghost(i).y), PinkySprite&, OR
        CASE 2: PUT (Ghost(i).x, Ghost(i).y), InkySprite&, OR
        CASE 3: PUT (Ghost(i).x, Ghost(i).y), DinkySprite&, OR
        CASE 4: PUT (Ghost(i).x, Ghost(i).y), SueSprite&, OR
      END SELECT
  END SELECT
NEXT
END SUB

SUB DrawPacMan
SHARED pac1&(), pacl1&(), pacl2&(), pacl3&(), pacr1&(), pacr2&(), pacr3&()
SHARED pacd1&(), pacd2&(), pacd3&(), pacu1&(), pacu2&(), pacu3&(), Scrn%()
SHARED PacMask&(), HoldX%, HoldY%
STATIC PM%

PM% = PM% + 1

REM The if statements make Pacman face left and not eat if he is not on a dot.
IF Scrn%((x% - ScrX) / 16, (y% - ScrY) / 16) <> Pellet AND Scrn%((x% - ScrX) / 16, (y% - ScrY) / 16) <> PowerPellet THEN PM% = 3

PUT (HoldX% - 14, HoldY% - 14), PacMask&, AND
CALL Remain(HoldX% - 15, HoldY% - 15, (AddX%), (AddY%))
PUT (x% - 14, y% - 14), PacMask&, AND

SELECT CASE PM%
  CASE IS = 1
    PUT (x% - 14, y% - 14), pac1&, OR

  CASE IS = 2, 6
    REM Down
    IF AddY% > 0 AND AddX% = 0 THEN
      PUT (x% - 14, y% - 14), pacd1&, OR
    END IF
  
    REM Up
    IF AddY% < 0 AND AddX% = 0 THEN
      PUT (x% - 14, y% - 14), pacu1&, OR
    END IF
   
    REM Left
    IF AddX% < 0 AND AddY% = 0 THEN
      PUT (x% - 14, y% - 14), pacl1&, OR
    END IF

    REM Right
    IF AddX% >= 0 AND AddY% = 0 THEN
      PUT (x% - 14, y% - 14), pacr1&, OR
    END IF

  CASE IS = 3, 5
    REM Down
    IF AddY% > 0 AND AddX% = 0 THEN
      PUT (x% - 14, y% - 14), pacd2&, OR
    END IF
   
    REM Up
    IF AddY% < 0 AND AddX% = 0 THEN
      PUT (x% - 14, y% - 14), pacu2&, OR
    END IF
   
    REM Left
    IF AddX% < 0 AND AddY% = 0 THEN
      PUT (x% - 14, y% - 14), pacl2&, OR
    END IF
    
    REM Right
    IF AddX% >= 0 AND AddY% = 0 THEN
      PUT (x% - 14, y% - 14), pacr2&, OR
    END IF

  CASE IS = 4
    REM Down
    IF AddY% > 0 AND AddX% = 0 THEN
      PUT (x% - 14, y% - 14), pacd3&, OR
    END IF
   
    REM Up
    IF AddY% < 0 AND AddX% = 0 THEN
      PUT (x% - 14, y% - 14), pacu3&, OR
    END IF
  
    REM Left
    IF AddX% < 0 AND AddY% = 0 THEN
      PUT (x% - 14, y% - 14), pacl3&, OR
    END IF

    REM Right
    IF AddX% >= 0 AND AddY% = 0 THEN
      PUT (x% - 14, y% - 14), pacr3&, OR
    END IF

  CASE IS = 7
    PM% = 0
END SELECT

END SUB

SUB Eaten (i AS INTEGER, Status%)
SHARED GhostKill%, Ghost() AS GhostType, LastStatus%()

REM If PacMan dies.
IF Status% = Normal THEN
  DeadPac
ELSE
  IF GhostKill% <= 5 THEN GhostKill% = GhostKill% + 1
  Points (100 * 2 ^ GhostKill%)
  
  REM Redraws the PacMan that got erased by the points SUB.  This SUB CALL
  REM serves no purpose unless PacMan get several ghosts.
  'DrawPacMan

  REM Lets one blue ghsot die
  Ghost(i).Status = Eyes
 
  LINE (Ghost(i).x, Ghost(i).y)-(Ghost(i).x + 28, Ghost(i).y + 28), 0, BF

END IF

END SUB

SUB FigureScreen
SHARED GetFruit%, Difficulty%, Scrn%()

REM Tells the Scrn% array where the pellets and power pellets are.

'IF Stage% = 15 THEN
'  FOR y5% = 0 TO 26 STEP 26
'  FOR x5% = 0 TO 26
'    Scrn%(x5%, y5%) = Empty
'    LINE (x5% * 16 + 116, y5% * 16 + 30)-(x5% * 16 + 132, y5% * 16 + 46), 0, BF
'  NEXT: NEXT
'  FOR y5% = 0 TO 26
'  FOR x5% = 0 TO 26 STEP 26
'    Scrn%(x5%, y5%) = Empty
'    LINE (x5% * 16 + 116, y5% * 16 + 30)-(x5% * 16 + 132, y5% * 16 + 46), 0, BF
'  NEXT: NEXT
'  PUT (Ghost(2).x, Ghost(2).y), InkySprite&
'END IF

REM On level fifteen the walls are blacked out.  These lines take care of the
REM 8 pixels on the edges of the screen.
IF Stage% = 15 THEN
  LINE (ScrX, ScrY)-(ScrX + ScrLen, ScrY + 8), 0, BF
  LINE (ScrX, ScrY)-(ScrX + 8, ScrY + ScrLen), 0, BF
  LINE (ScrX + ScrLen - 8, ScrY)-(ScrX + ScrLen, ScrY + ScrLen - 8), 0, BF
  LINE (ScrX + 8, ScrY + ScrLen - 8)-(ScrX + ScrLen, ScrY + ScrLen), 0, BF
END IF

FOR y5% = ScrY + 16 TO ScrY + ScrLen - 16 STEP 16
FOR x5% = ScrX + 16 TO ScrX + ScrLen - 16 STEP 16
  SELECT CASE POINT(x5%, y5%)
   CASE IS = 8
     IF Difficulty% = Easy THEN
       LINE (x5% - 2, y5% - 2)-(x5% + 2, y5% + 2), DotColor, BF
     ELSE
       LINE (x5% - 2, y5% - 3)-(x5% + 4, y5% + 4), 0, BF
       CIRCLE (x5% + 1, y5% + 1), 3, DotColor
       PAINT (x5% + 1, y5% + 1), DotColor
     END IF
    
     Scrn%((x5% - ScrX) / 16, (y5% - ScrY) / 16) = Pellet
     Pellets% = Pellets% + 1
   CASE IS = 15
     Scrn%((x5% - ScrX) / 16, (y5% - ScrY) / 16) = PowerPellet
     Pellets% = Pellets% + 1
   CASE ELSE
     Scrn%((x5% - ScrX) / 16, (y5% - ScrY) / 16) = Wall
     IF Stage% = 15 THEN
       REM blacks out the walls on stage 15
       LINE (x5% - 8, y5% - 8)-(x5% + 8, y5% + 8), 0, BF
     END IF
  END SELECT
NEXT: NEXT

IF Stage% = 15 THEN
  SHARED InkySprite&(), GhostMask&(), Ghost() AS GhostType
  FOR i% = 1 TO 4
    IF i% = 2 THEN
      PUT (Ghost(i%).x, Ghost(i%).y), GhostMask&, AND
      CALL Remain(Ghost(i%).x, Ghost(i%).y, 16, 16)
    END IF
    CALL DrawGhost(i%)
  NEXT
END IF

GetFruit% = RND * (Pellets% / 2 - 10) + Pellets% / 2 - 10
END SUB

SUB GetPellet
SHARED Mute%, Ghost() AS GhostType, PowerOn%, slowing!, Scrn%()
 
  REM checks to see if PacMan got a pellet
  SELECT CASE Scrn%((x% - ScrX) / 16, (y% - ScrY) / 16)
    CASE IS = PowerPellet
      REM Detects if PacMan got a power pellet-which has an array value of 2.
      Scrn%((x% - ScrX) / 16, (y% - ScrY) / 16) = Empty
      PowerOn% = true
      REM The IFs make the ghosts not turn blue from a power pellet when they
      REM are eyes.
      IF Ghost(1).Status <> Eyes THEN Ghost(1).Status = Blue
      IF Ghost(3).Status <> Eyes THEN Ghost(3).Status = Blue
      IF Ghost(2).Status <> Eyes THEN Ghost(2).Status = Blue
      IF Ghost(4).Status <> Eyes THEN Ghost(4).Status = Blue
      GhostLimit% = GhostLimit% + 3 * Blink + (10 * slowing!) - (3 * Stage%)
      Score& = Score& + 50
      Pellets% = Pellets% - 1
      IF Mute% = false THEN SOUND 250, .2: SOUND 200, 1: SOUND 300, 1: SOUND 500, .5: SOUND 550, .2

    CASE IS = Pellet
      REM This checks if PacMan picked up a pellet-array value of 1.
      Scrn%((x% - ScrX) / 16, (y% - ScrY) / 16) = Empty
      Score& = Score& + 10
      IF Mute% = false THEN SOUND 555, .1 '175, .3
      Pellets% = Pellets% - 1
  END SELECT

  IF Pellets% = 0 THEN NextStage

END SUB

SUB GhostFollow (i AS INTEGER)
SHARED Movement%(), Ghost() AS GhostType
REM Artificial intellegence SUB of ghosts that makes them follow PacMan

'CurMov% = Movement%((Ghost(i).X - (ScrX - 15)) / 16, (Ghost(i).Y - (ScrY - 15)) / 16)
 
  FOR ay% = -16 TO 16 STEP 32
    IF Ghost(i).Status = Blue THEN
      IF Movement%((Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15) + ay%) / 16) < CurMov% AND Movement%((Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15) + ay%) / 16) > 0 THEN
        CurMov% = Movement%((Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15) + ay%) / 16)
        Ghost(i).AddX = 0: Ghost(i).AddY = ay%
      END IF
    ELSE
      IF Movement%((Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15) + ay%) / 16) > CurMov% THEN
        CurMov% = Movement%((Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15) + ay%) / 16)
        Ghost(i).AddX = 0: Ghost(i).AddY = ay%
      END IF
    END IF
  NEXT
  FOR ax% = -16 TO 16 STEP 32
    IF Ghost(i).Status = Blue THEN
      IF Movement%((Ghost(i).x - (ScrX - 15) + ax%) / 16, (Ghost(i).y - (ScrY - 15)) / 16) < CurMov% AND Movement%((Ghost(i).x - (ScrX - 15) + ax%) / 16, (Ghost(i).y - (ScrY - 15)) / 16) > 0 THEN
        CurMov% = Movement%((Ghost(i).x - (ScrX - 15) + ax%) / 16, (Ghost(i).y - (ScrY - 15)) / 16)
        Ghost(i).AddX = ax%: Ghost(i).AddY = 0
      END IF
    ELSE
      IF Movement%((Ghost(i).x - (ScrX - 15) + ax%) / 16, (Ghost(i).y - (ScrY - 15)) / 16) > CurMov% THEN
        CurMov% = Movement%((Ghost(i).x - (ScrX - 15) + ax%) / 16, (Ghost(i).y - (ScrY - 15)) / 16)
        Ghost(i).AddX = ax%: Ghost(i).AddY = 0
      END IF
    END IF
  NEXT


IF CurMov% = Movement%((Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15)) / 16) OR CurMov% = 0 THEN
  Ghost(i).ThinkWith = Think
END IF

MoveGhost (i)
END SUB

SUB GhostThink (i AS INTEGER)
SHARED Ghost() AS GhostType
DIM up(1 TO 4) AS STRING * 1, left(1 TO 4) AS STRING * 1, down(1 TO 4) AS STRING * 1, right(1 TO 4) AS STRING * 1

REM The -15 corrects the poor alignment of the ghosts and PacMan.
distHorz% = x% - Ghost(i).x - 15: distVert% = y% - Ghost(i).y - 15
REM distHorz% is positive when PacMan is to the ghost's right
REM disVert% is positive when Pacman is below the ghost

IF distHorz% < 0 THEN
  IF right(i) <> "t" THEN
    Ghost(i).AddX = -16: Ghost(i).AddY = 0
    up(i) = "f": down(i) = "f"
    IF Ghost(i).Status = Blue THEN Ghost(i).AddX = -Ghost(i).AddX: Ghost(i).AddY = -Ghost(i).AddY
    MoveGhost (i)
  END IF
END IF
IF distHorz% > 0 THEN
  IF left(i) <> "t" THEN
    Ghost(i).AddX = 16: Ghost(i).AddY = 0
    up(i) = "f": down(i) = "f"
    IF Ghost(i).Status = Blue THEN Ghost(i).AddX = -Ghost(i).AddX: Ghost(i).AddY = -Ghost(i).AddY
    MoveGhost (i)
  END IF
END IF
 
IF distVert% < 0 THEN
  IF down(i) <> "t" THEN
    Ghost(i).AddY = -16: Ghost(i).AddX = 0
    left(i) = "f": right(i) = "f"
    IF Ghost(i).Status = Blue THEN Ghost(i).AddX = -Ghost(i).AddX: Ghost(i).AddY = -Ghost(i).AddY
    MoveGhost (i)
  END IF
END IF
IF distVert% > 0 THEN
  IF up(i) <> "t" THEN
    Ghost(i).AddY = 16: Ghost(i).AddX = 0
    left(i) = "f": right(i) = "f"
    IF Ghost(i).Status = Blue THEN Ghost(i).AddX = -Ghost(i).AddX: Ghost(i).AddY = -Ghost(i).AddY
    MoveGhost (i)
  END IF
END IF

END SUB

SUB HiScore
SHARED max%, RankPlace%, HiScores&(), HiScores$()
REM This sub discerns where a score is listed among the high scores, enters
REM the current score among them if it is high enough, then prints out the
REM High-Score listing.

REM The File containing the high scores has been opened in the Load sub.

CLS
IF RankPlace% < 20 THEN
 
 
  REM Moves the scores with lower rank than the present scores down a rank.
  FOR Rank% = 19 TO RankPlace% + 1 STEP -1
    HiScores&(Rank% + 1) = HiScores&(Rank%)
    HiScores$(Rank% + 1) = HiScores$(Rank%)
  NEXT
 
  REM Inputs the players name and score.
  LOCATE 12, 28
  INPUT "Enter your name"; Name$
  IF Name$ = "" THEN Name$ = DATE$ + "/" + TIME$
  HiScores$(RankPlace% + 1) = Name$
  HiScores&(RankPlace% + 1) = Score&
 
  OPEN path$ + "HiScores" FOR OUTPUT AS #1
  
    FOR Rank2% = 1 TO 20
      WRITE #1, HiScores&(Rank2%)
      WRITE #1, HiScores$(Rank2%)
    NEXT
   
    IF RankPlace% + 1 = 1 THEN
      LOCATE 13, 28
      INPUT "Enter a quote"; HiScores$(21)
      REM The ifs take out " if they were inputted.
      IF LEFT$(HiScores$(21), 1) = CHR$(34) THEN HiScores$(21) = RIGHT$(HiScores$(21), LEN(HiScores$(21)) - 1)
      IF RIGHT$(HiScores$(21), 1) = CHR$(34) THEN HiScores$(21) = LEFT$(HiScores$(21), LEN(HiScores$(21)) - 1)
    END IF
  WRITE #1, HiScores$(21)
  CLOSE #1
  SHELL "attrib +h " + path$ + "HiScores"
END IF
CLS

REM Opens and prints out the Hi-Score listing.
LOCATE 3, 32
PRINT "HI-SCORE LISTING"
OPEN path$ + "HiScores" FOR INPUT AS #1
  FOR Rank% = 1 TO 20
    IF NOT EOF(1) THEN
      INPUT #1, HiScores&(Rank%)
      INPUT #1, HiScores$(Rank%)
    END IF
    SELECT CASE Rank%
     CASE IS = RankPlace% + 1
       COLOR 9
     CASE IS = 1
       COLOR 10
     CASE IS = 2
       COLOR 4
     CASE IS = 3
       COLOR 14
     CASE ELSE
       COLOR 15
    END SELECT
   
    LOCATE Rank% + 5, 1
    PRINT Rank%; HiScores$(Rank%); " "; STRING$(77 - LEN(HiScores$(Rank%)) - LEN(Rank%), ".")
   
    LOCATE Rank% + 5, 80 - LEN(STR$(HiScores&(Rank%)))
    PRINT HiScores&(Rank%)
  NEXT

  REM Colors quote blue if it is new and green other-wise.
  IF RankPlace% = 0 THEN
    COLOR 9
  ELSE
    COLOR 10
  END IF
  IF NOT EOF(1) THEN
    INPUT #1, HiScores$(Rank%)
    place% = 39 - LEN(HiScores$(Rank%)) / 2
    LOCATE 4, place%
    PRINT CHR$(34); HiScores$(Rank%); CHR$(34)
  END IF
CLOSE #1

COLOR 15
SLEEP
END SUB

SUB Load
SHARED max%, Mute%, slowing!, Free&, Difficulty%, HiScores&(), HiScores$()
SHARED EyesSprite&(), InkySprite&(), DinkySprite&(), SueSprite&(), GhostMask&()
SHARED PinkySprite&(), BlueGhost&(), WhiteGhost&(), Ghost() AS GhostType
SHARED pac1&(), pacl1&(), pacl2&(), pacl3&(), pacr1&(), pacr2&(), pacr3&(), pacd1&(), pacd2&(), pacd3&(), pacu1&(), pacu2&(), pacu3&(), PacMask&()
REM This is the sub which loads all the graphics drawn in my graphics program.
CLS

'ON ERROR GOTO PacPathError
'OPEN "\PacPath" FOR INPUT AS #1
'  INPUT #1, path$
' CLOSE #1
PacPath$ = ""

REM Load information reguarding the Hi-Scores.
ON ERROR GOTO HiScoreError
OPEN path$ + "HiScores" FOR INPUT AS #1
  FOR rn% = 1 TO 20
   INPUT #1, HiScores&(rn%)
   INPUT #1, HiScores$(rn%)
  NEXT
  REM the quote; rn% now equals 21
  INPUT #1, HiScores$(rn%)
CLOSE #1

ON ERROR GOTO MaxError
OPEN path$ + "max" FOR INPUT AS #1
  INPUT #1, max%
  INPUT #1, Mute%
  INPUT #1, Difficulty%
CLOSE #1

ON ERROR GOTO ErrorKiller

SELECT CASE Difficulty%
  CASE Easy
    slowing! = .24
    Free& = 30000
  CASE Normal
    Free& = 50000
    slowing! = .18
  CASE Hard
    slowing! = .12
    Free& = 70000
END SELECT
'----------------------------------------------------------------------------
DEF SEG = VARSEG(EyesSprite&(0))
BLOAD path$ + "Eyes.grh", VARPTR(EyesSprite&(0))

DEF SEG = VARSEG(InkySprite&(0))
BLOAD path$ + "Inky.grh", VARPTR(InkySprite&(0))
PUT (Ghost(2).x, Ghost(2).y), InkySprite&

REM Pinky-the purplish-pink ghost.
DEF SEG = VARSEG(PinkySprite&(0))
BLOAD path$ + "Pinky.grh", VARPTR(PinkySprite&(0))
PUT (Ghost(1).x, Ghost(1).y), PinkySprite&
'----------------------------------------------------------------------------
CALL MakeMask(GhostMask&(), Ghost(1).x, Ghost(1).y, Ghost(1).x + 28, Ghost(1).y + 28)

REM The Ghosts Dinky, and Sue are made by scaning over pinky and copying it
REM to a new location as a different color.

REM Dinky:  Dark-Blue
FOR Gx1% = FNInitPos%("x", 1) TO FNInitPos%("x", 1) + 28
FOR Gy1% = FNInitPos%("y", 1) TO FNInitPos%("y", 1) + 28
  IF POINT(Gx1%, Gy1%) = 13 THEN
    PSET (Gx1% + 64, Gy1%), 1
  ELSE
    PSET (Gx1% + 64, Gy1%), POINT(Gx1%, Gy1%)
  END IF
NEXT: NEXT
GET (FNInitPos%("x", 3), FNInitPos%("y", 3))-(FNInitPos%("x", 3) + 28, FNInitPos%("y", 3) + 28), DinkySprite&

REM Sue:  Red
FOR Gx1% = FNInitPos%("x", 1) TO FNInitPos%("x", 1) + 28
FOR Gy1% = FNInitPos%("y", 1) TO FNInitPos%("y", 1) + 28
  IF POINT(Gx1%, Gy1%) = 13 THEN
    PSET (Gx1% + 32, Gy1%), 5
  ELSE
    PSET (Gx1% + 32, Gy1%), POINT(Gx1%, Gy1%)
  END IF
NEXT: NEXT
GET (FNInitPos%("x", 4), FNInitPos%("y", 4))-(FNInitPos%("x", 4) + 28, FNInitPos%("y", 4) + 28), SueSprite&

REM The Blue-Ghost is drawn in SetStage.

REM The White-Ghost(When PacMan has a power pellet).
FOR Gx1% = FNInitPos%("x", 1) TO FNInitPos%("x", 1) + 28
FOR Gy1% = FNInitPos%("y", 1) TO FNInitPos%("y", 1) + 28
 SELECT CASE POINT(Gx1%, Gy1%)
  CASE IS = 13
   PSET (Gx1%, Gy1%), 15
  CASE ELSE
   PSET (Gx1%, Gy1%), 0
 END SELECT
NEXT: NEXT
GET (FNInitPos%("x", 1), FNInitPos%("y", 1))-(FNInitPos%("x", 1) + 28, FNInitPos%("y", 1) + 28), WhiteGhost&
PUT (FNInitPos%("x", 1), FNInitPos%("y", 1)), PinkySprite&, PSET
'----------------------------------------------------------------------------
CIRCLE (x%, y%), 14, 14
PAINT (x%, y%), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pac1&
CALL MakeMask(PacMask&(), x% - 14, y% - 14, x% + 14, y% + 14)
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF

REM Down
CIRCLE (x%, y%), 14, 14, 1.6 * Pi, 1.4 * Pi
LINE (x%, y%)-(x% - FNcosine(.4), y% + FNsine(.4)), 14
LINE (x%, y%)-(x% + FNcosine(.4), y% + FNsine(.4)), 14
PAINT (x%, y% - 1), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacd1&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF

REM Up
CIRCLE (x%, y%), 14, 14, .6 * Pi, .4 * Pi
LINE (x%, y%)-(x% - FNcosine(.4), y% - FNsine(.4)), 14
LINE (x%, y%)-(x% + FNcosine(.4), y% - FNsine(.4)), 14
PAINT (x%, y% + 1), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacu1&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF

REM Left
CIRCLE (x%, y%), 14, 14, 1.1 * Pi, .9 * Pi
LINE (x%, y%)-(x% - FNcosine(.1), y% - FNsine(.1)), 14
LINE (x%, y%)-(x% - FNcosine(.1), y% + FNsine(.1)), 14
PAINT (x% + 1, y%), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacl1&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF

REM Right
CIRCLE (x%, y%), 14, 14, .1 * Pi, 1.9 * Pi
LINE (x%, y%)-(x% + FNcosine(.1), y% - FNsine(.1)), 14
LINE (x%, y%)-(x% + FNcosine(.1), y% + FNsine(.1)), 14
PAINT (x% - 1, y%), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacr1&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF

REM Down
CIRCLE (x%, y%), 14, 14, 1.7 * Pi, 1.3 * Pi
LINE (x%, y%)-(x% - FNcosine(.3), y% + FNsine(.3)), 14
LINE (x%, y%)-(x% + FNcosine(.3), y% + FNsine(.3)), 14
PAINT (x%, y% - 1), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacd2&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF
  
REM Up
CIRCLE (x%, y%), 14, 14, .7 * Pi, .3 * Pi
LINE (x%, y%)-(x% - FNcosine(.3), y% - FNsine(.3)), 14
LINE (x%, y%)-(x% + FNcosine(.3), y% - FNsine(.3)), 14
PAINT (x%, y% + 1), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacu2&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF
  
REM Left
CIRCLE (x%, y%), 14, 14, 1.2 * Pi, .8 * Pi
LINE (x%, y%)-(x% - FNcosine(.2), y% - FNsine(.2)), 14
LINE (x%, y%)-(x% - FNcosine(.2), y% + FNsine(.2)), 14
PAINT (x% + 1, y%), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacl2&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF
   
REM Right
CIRCLE (x%, y%), 14, 14, .2 * Pi, 1.8 * Pi
LINE (x%, y%)-(x% + FNcosine(.2), y% - FNsine(.2)), 14
LINE (x%, y%)-(x% + FNcosine(.2), y% + FNsine(.2)), 14
PAINT (x% - 1, y%), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacr2&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF

REM Down
CIRCLE (x%, y%), 14, 14, 1.8 * Pi, 1.2 * Pi
LINE (x%, y%)-(x% - FNcosine(.2), y% + FNsine(.2)), 14
LINE (x%, y%)-(x% + FNcosine(.2), y% + FNsine(.2)), 14
PAINT (x%, y% - 1), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacd3&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF
  
REM Up
CIRCLE (x%, y%), 14, 14, .8 * Pi, .2 * Pi
LINE (x%, y%)-(x% - FNcosine(.2), y% - FNsine(.2)), 14
LINE (x%, y%)-(x% + FNcosine(.2), y% - FNsine(.2)), 14
PAINT (x%, y% + 1), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacu3&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF
 
REM Left
CIRCLE (x%, y%), 14, 14, 1.3 * Pi, .7 * Pi
LINE (x%, y%)-(x% - FNcosine(.3), y% - FNsine(.3)), 14
LINE (x%, y%)-(x% - FNcosine(.3), y% + FNsine(.3)), 14
PAINT (x% + 1, y%), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacl3&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF

REM Right
CIRCLE (x%, y%), 14, 14, .3 * Pi, 1.7 * Pi
LINE (x%, y%)-(x% + FNcosine(.3), y% - FNsine(.3)), 14
LINE (x%, y%)-(x% + FNcosine(.3), y% + FNsine(.3)), 14
PAINT (x% - 1, y%), 14
GET (x% - 14, y% - 14)-(x% + 14, y% + 14), pacr3&
LINE (x% - 14, y% - 14)-(x% + 14, y% + 14), 0, BF

NextFruit
END SUB

SUB Lost
SHARED RankPlace%, NoPrize%, Difficulty%, Ik$, LastScore&
CONST BoxWidth = 62, BoxHeight = 32
DIM ExtraSpc%, CenterCol%

REM ExtraSpc% (Extra Space) used to add one if the player made the hiscore
REM list.  RankPlace% is < 20 if he makes the list so the expression evaulates
REM to one, otherwise RankPlace% = 20 and the extression evaulates to 0.
ExtraSpc% = INT((39 - RankPlace%) / 20)
CenterCol% = FNTextX%(CenterX)

LINE (CenterX - BoxWidth - 1, CenterY - BoxHeight - 1)-(CenterX + BoxWidth + 1, CenterY + BoxHeight + ExtraSpc% * 16 - 1), 0, BF
LINE (CenterX - BoxWidth - 2, CenterY - BoxHeight - 2)-(CenterX + BoxWidth + 2, CenterY + BoxHeight + ExtraSpc% * 16), 15, B

p$ = CHR$(34) + "c" + CHR$(34) + " to continue"
LOCATE 14, CenterCol% - LEN(p$) / 2 '42
PRINT p$

p$ = CHR$(34) + "r" + CHR$(34) + " to restart "
LOCATE 15, CenterCol% - LEN(p$) / 2
PRINT p$

LOCATE 16, CenterCol% - 7
IF RankPlace% = 20 THEN
  PRINT CHR$(34) + "e" + CHR$(34) + " to exit   "
ELSE
  PRINT CHR$(34) + "e" + CHR$(34) + " to exit w/"
END IF

IF RankPlace% < 20 THEN
  LOCATE 17, CenterCol% - 3
  PRINT "a Hi-Score"
END IF

REM The WHILE LOOP takes keystrokes out of the buffer.
WHILE INKEY$ <> "": WEND

Times% = 11
DO UNTIL Times% = 0
  Times% = Times% - 1
  REM The + ExtraSpc% (Extra Space) adds one on the row if the player made the
  REM hiscore list because an extra line is used up to say "with hiscore".
  LOCATE 17 + ExtraSpc%, CenterCol% - 2
  PRINT Times%
  REM The next five lines causes a second pause for every number.  The pause
  REM can be cut short by the user pressing a key.
  Time! = TIMER
  Con$ = ""
  WHILE TIMER - Time! < 1 AND Con$ = ""
    Con$ = INKEY$
  WEND
  IF LCASE$(Con$) = "t" THEN Times% = 11
  IF LCASE$(Con$) = "e" OR Times% = 0 THEN
    HiScore
    CLS
    LOCATE 15, 36
    PRINT "Game Over"
    Ik$ = CHR$(27)
    Times% = 0
    SLEEP
  END IF
  IF LCASE$(Con$) = "r" THEN Ik$ = "Restart": EXIT SUB
  IF LCASE$(Con$) = "c" OR Con$ = CHR$(13) THEN
    Times% = 0
   
    REM divides Score& by 2 but kees is a mutiple of 10
    Score& = INT(Score& / 20) * 10
    LastScore& = Score&
    PrintAttr (TheScore)

    IF RankPlace% < 20 THEN
      LOCATE 1, 19
      PRINT SPC(LEN(STR$(RankPlace%)));
      RankPlace% = 20
    END IF
   
    Lives% = 3

    PrintAttr (TheLives)
    Stage% = Stage% - 1
    NoPrize% = true
    NextStage
  END IF
LOOP

END SUB

SUB MainOperations
STATIC LastTimeMod%, FruitCount!
SHARED RankPlace%, LastScore&, GetFruit%, Free&, PowColor%, Fruit$, SecretStage%
SHARED PowerOn%, Secret%, HiScores&(), Scrn%()

'IF Delay$ = "" THEN
  REM The game's delay.
'  DO UNTIL TIMER - Begin! >= Delay!: LOOP
  REM The "Begin! = TIMER" is put after the DO UNTIL TIMER LOOP(above) so that
  REM my delay will "absorb" unexpected delays in the game.
'  Begin! = TIMER
'END IF

REM If the time(enough pellets) comes to get the fruit.
IF Pellets% = GetFruit% AND (Fruit$ = "" OR Fruit$ = "a") THEN PutFruit

REM Determines out the players rank among the hi-scorers.  RankPlace% is
REM actually one higher then the current rank.
IF RankPlace% > 0 THEN
  IF Score& > HiScores&(1) THEN
    RankPlace% = 0
    PrintAttr (TheRank)
  ELSEIF Score& > HiScores&(RankPlace%) THEN
    DO UNTIL HiScores&(RankPlace%) >= Score&
      RankPlace% = RankPlace% - 1
    LOOP
    PrintAttr (TheRank)
  END IF
END IF

REM Gives a freelife every Free& x 10,000 points.
REM Free& = 30,000 on easy, 50,000 on normal and 70,000 on hard.
IF LastScore& MOD Free& > Score& MOD Free& THEN
  Lives% = Lives% + 1
  PrintAttr (TheLives)
END IF

REM The printing out of the Score.
IF Score& <> LastScore& THEN
  PrintAttr (TheScore)
  LastScore& = Score&
END IF

IF Stage% = 90 THEN
  REM Top left ball
  IF Scrn%(6, 2) = Pellet AND Scrn%(6, 4) = Pellet AND Scrn%(8, 4) = Pellet THEN Balls% = Balls% + 1
  REM Top right ball
  IF Scrn%(18, 4) = Pellet AND Scrn%(20, 4) = Pellet AND Scrn%(20, 2) = Pellet THEN Balls% = Balls% + 1
  REM Bottom left ball
  IF Scrn%(6, 22) = Pellet AND Scrn%(8, 22) = Pellet AND Scrn%(6, 24) = Pellet THEN Balls% = Balls% + 1
  REM Bottom right ball
  IF Scrn%(18, 22) = Pellet AND Scrn%(20, 22) = Pellet AND Scrn%(20, 24) = Pellet THEN Balls% = Balls% + 1
 
  IF Pellets% = Balls% * 8 AND Pellets% > 0 THEN
    Secret% = 90
    NextStage
  END IF
END IF

IF Stage% = 3 AND Pellets% = 1 AND Secret% = 0 THEN 'And Lost3$ = ""
  REM Stage 3 ghost-box warp to secret stages.
  x1% = CenterX - 16: y1% = CenterY - 32
  LINE (x1%, y1%)-(x1% + 32, y1% + 16), 0, B
  Scrn%(13, 11) = Empty
  Scrn%(13, 12) = Empty
  Scrn%(13, 13) = Empty
  Scrn%(13, 14) = -2
END IF

IF PowerOn% = false AND Stage% = 38 AND Pellets% = 85 THEN
  REM Stage 38 door
  Scrn%(13, 24) = Empty: Scrn%(13, 25) = Empty
  LINE (CenterX - 16, ScrY + ScrLen - 32)-(CenterX + 16, ScrY + ScrLen), 0, BF
END IF

IF Stage% = 8 AND Pellets% = 4 AND Scrn%(2, 2) = PowerPellet AND Scrn%(2, 21) = PowerPellet AND Scrn%(24, 2) = PowerPellet AND Scrn%(24, 21) = PowerPellet THEN
  REM Stage 8 door warp to secret stage.
  Scrn%(13, 24) = Empty: Scrn%(13, 25) = Empty: Scrn%(13, 26) = -3
  LINE (CenterX - 16, ScrY + ScrLen - 17)-(CenterX + 16, ScrY + ScrLen), 0, BF
END IF

REM Prints out power blinking pellets.
REM The purpose of the la% and IF statement is to make the power-pellets print
REM out less often because that is a relatively slow process.
TimeMod% = INT(TIMER * 3) MOD 2
IF TimeMod% <> LastTimeMod% THEN
   LastTimeMod% = TimeMod%
   FOR x5% = ScrX + 32 TO ScrX + ScrLen - 32 STEP ScrLen - 64
   FOR y5% = ScrY + 32 TO ScrY + ScrLen - 64 STEP ScrLen - 112
     IF Scrn%((x5% - ScrX) / 16, (y5% - ScrY) / 16) = PowerPellet THEN
       CIRCLE (x5%, y5%), 6, PowColor% + TimeMod% * 8
       PAINT (x5%, y5%), PowColor% + TimeMod% * 8
     END IF
   NEXT: NEXT
END IF

Biten
IF (Fruit$ = "t" OR Fruit$ = "l") AND TIMER - FruitCount! > .13 THEN
  FruitCount! = TIMER
  MovePrize
END IF
MoveGhosts
PelletCounter
IF FNMovePac = true THEN MovePac

REM GameEnding by Death.
IF Lives% <= 0 THEN Lost
END SUB

SUB MakeMask (MaskAry&(), x1%, y1%, x2%, y2%)
DIM BackGround&(FNSize&(ABS(x2% - x1%), ABS(y2% - y1%)))
GET (x1%, y1%)-(x2%, y2%), BackGround&

FOR x3% = x1% TO x2%
  FOR y3% = y1% TO y2%
    IF POINT(x3%, y3%) = 0 THEN
      PSET (x3%, y3%), 15
    ELSE
      PSET (x3%, y3%), 0
    END IF
  NEXT
NEXT

GET (x1%, y1%)-(x2%, y2%), MaskAry&
PUT (x1%, y1%), BackGround&, PSET
END SUB

SUB MoveEyes (i AS INTEGER)
SHARED EyeTrail%(), Ghost() AS GhostType

InitY% = FNInitPos%("y", i)
IF i = 2 THEN InitY% = InitY% + 48

IF Ghost(i).x <> FNInitPos%("x", i) OR Ghost(i).y <> InitY% THEN
  IF i = 2 AND Ghost(i).x = FNInitPos%("x", i) AND Ghost(i).y < InitY% AND Ghost(i).y >= 177 THEN
    Ghost(i).AddY = 16: Ghost(i).AddX = 0
  ELSE
    FOR aix% = -16 TO 16 STEP 32
      IF EyeTrail%(i, (Ghost(i).x - (ScrX - 15) + aix%) / 16, (Ghost(i).y - (ScrY - 15)) / 16) > it% THEN
         it% = EyeTrail%(i, (Ghost(i).x - (ScrX - 15) + aix%) / 16, (Ghost(i).y - (ScrY - 15)) / 16)
         Ghost(i).AddX = aix%: Ghost(i).AddY = 0
      END IF
    NEXT
   
    FOR aiy% = -16 TO 16 STEP 32
      IF EyeTrail%(i, (Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15) + aiy%) / 16) > it% THEN
        it% = EyeTrail%(i, (Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15) + aiy%) / 16)
        Ghost(i).AddX = 0: Ghost(i).AddY = aiy%
      END IF
    NEXT
  END IF
 
  MoveGhost (i)

ELSE
  FOR x1% = 1 TO 26
    FOR y1% = 1 TO 26
      EyeTrail%(i, x1%, y1%) = 0
  NEXT: NEXT
 
  Ghost(i).Trail = MaxInt
  Ghost(i).Status = Normal
  Ghost(i).LastX = Ghost(i).x: Ghost(i).LastY = Ghost(i).y
  REM The if erases the "eyes resedue" Dinky and Pinky leave.
  IF i MOD 2 = 1 THEN
    LINE (Ghost(i%).x + 10, Ghost(i%).y + 5)-(Ghost(i%).x + 14, Ghost(i%).y + 12), 0, BF
    LINE (Ghost(i%).x + 18, Ghost(i%).y + 5)-(Ghost(i%).x + 22, Ghost(i%).y + 12), 0, BF
  END IF
  DrawGhost (i)
  Ghost(i).ThinkWith = Init
  Ghost(i).Delay = TIMER + 1
END IF

END SUB

SUB MoveGhost (i AS INTEGER)
SHARED Scrn%(), Ghost() AS GhostType

REM The Hold variables are the coordinates of the Ghost's last position.
Ghost(i).LastX = Ghost(i).x: Ghost(i).LastY = Ghost(i).y

REM The next if move Ghost out of the ghost-box.
IF Ghost(i).Status <> Eyes THEN
  REM moves up
  IF Ghost(i).x = ScrX + ScrLen / 2 - 15 AND Ghost(i).y <= ScrY + ScrLen / 2 - 15 AND Ghost(i).y > ScrY + ScrLen / 2 - 63 THEN Ghost(i).AddY = -16: Ghost(i).AddX = 0
  IF Ghost(i).y = ScrY + ScrLen / 2 - 15 THEN
    REM moves right
    IF Ghost(i).x >= ScrX + ScrLen / 2 - 47 AND Ghost(i).x < ScrX + ScrLen / 2 - 15 THEN Ghost(i).AddX = 16: Ghost(i).AddY = 0
    REM moves left
    IF Ghost(i).x <= ScrX + ScrLen / 2 + 17 AND Ghost(i).x > ScrX + ScrLen / 2 - 15 THEN Ghost(i).AddX = -16: Ghost(i).AddY = 0
  END IF
END IF
'----------------------------------------------------------------------------
REM Prevents Ghost from going back into the ghost box.
IF Ghost(i).Status <> Eyes AND Ghost(i).x = ScrX + ScrLen / 2 - 15 AND Ghost(i).y = ScrY + ScrLen / 2 - 63 THEN
  IF Ghost(i).AddY = 16 THEN Ghost(i).AddY = 0
END IF
'----------------------------------------------------------------------------
IF Ghost(i).Status <> Eyes AND ControlGhost% = i AND Scrn%((Ghost(i).x - (ScrX - 15) + Ghost(i).AddX1) / 16, (Ghost(i).y - (ScrY - 15) + Ghost(i).AddY1) / 16) <> Wall THEN Ghost(i).AddX = Ghost(i).AddX1: Ghost(i).AddY = Ghost(i).AddY1

REM The IF NOT statement keeps the ghost from oscillating in the tunnel when
REM the ghost is blue and using Think.
IF NOT (Ghost(i).Status = Blue AND Ghost(i).ThinkWith = Think AND ((Ghost(i).x + 15 - ScrX) MOD ScrLen = 0 OR (Ghost(i).y + 15 - ScrY) MOD ScrLen = 0)) THEN
  Ghost(i).x = Ghost(i).x + Ghost(i).AddX: Ghost(i).y = Ghost(i).y + Ghost(i).AddY
END IF
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
REM Keeps Ghost from going into any obstructions.

REM The first IF makes the Ghost able to move around in the Ghost-Box which is
REM considered an obstructions.
IF Ghost(i).Status <> Eyes AND (Ghost(i).x < ScrX + ScrLen / 2 - 47 OR Ghost(i).x > ScrX + ScrLen / 2 + 17 OR Ghost(i).y < ScrY + ScrLen / 2 - 15 OR Ghost(i).y > ScrY + ScrLen / 2 - 15) THEN
  IF NOT Ghost(i).Status = Eyes AND NOT (Ghost(i).x = ScrX + ScrLen / 2 - 15 AND Ghost(i).y <= ScrY + ScrLen / 2 - 15 AND Ghost(i).y >= ScrY + ScrLen / 2 - 47) THEN
    REM This if detects obstructions and prevents Ghost from going into them.
    IF Scrn%((Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15)) / 16) = Wall THEN
      Ghost(i).y = Ghost(i).y - Ghost(i).AddY: Ghost(i).x = Ghost(i).x - Ghost(i).AddX
    END IF
  END IF
END IF
'----------------------------------------------------------------------------
IF Ghost(i).LastX <> Ghost(i).x OR Ghost(i).LastY <> Ghost(i).y THEN
 
  REM Tunnel Movement%s
  Tunnel% = FNAtEdge%(Ghost(i).x + 15, Ghost(i).y + 15, Ghost(i).AddX, Ghost(i).AddY)
  IF Ghost(i).Status = Blue AND Ghost(i).ThinkWith = Think AND Tunnel% > DeadEnd AND ControlGhost% <> i THEN
    Tunnel% = DeadEnd
  END IF
 
  SELECT CASE Tunnel%
    CASE GoThruX
      CALL AddTrail(Ghost(i).x, Ghost(i).y, i)
      Ghost(i).x = 2 * (ScrX - 15) + ScrLen - Ghost(i).x
      CALL AddTrail(Ghost(i).x, Ghost(i).y, i)
      Ghost(i).x = Ghost(i).x + Ghost(i).AddX
    CASE GoThruY
      CALL AddTrail(Ghost(i).x, Ghost(i).y, i)
      Ghost(i).y = 2 * (ScrY - 15) + ScrLen - Ghost(i).y
      CALL AddTrail(Ghost(i).x, Ghost(i).y, i)
      Ghost(i).y = Ghost(i).y + Ghost(i).AddY
    CASE DeadEnd
      Ghost(i).x = Ghost(i).x - Ghost(i).AddX
      Ghost(i).y = Ghost(i).y - Ghost(i).AddY
  END SELECT
 
  IF Tunnel% <> DeadEnd THEN CALL AddTrail(Ghost(i).LastX, Ghost(i).LastY, i)
END IF
'----------------------------------------------------------------------------
DrawGhost (i)

END SUB

SUB MoveGhosts
SHARED Ghost() AS GhostType

FOR i% = 1 TO 4
  IF Ghost(i%).Status = Eyes AND TIMER - Ghost(i%).Delay > SlowGhost! / 10 THEN
    Ghost(i%).Delay = TIMER
    MoveEyes (i%)
  ELSE
    IF TIMER - Ghost(i%).Delay > SlowGhost! THEN
      Ghost(i%).Delay = TIMER
      IF ControlGhost% = i% THEN
        MoveGhost (i%)
      ELSE
        SELECT CASE Ghost(i%).ThinkWith
          CASE Init: MoveInit (i%)
          CASE Think: GhostThink (i%)
          CASE Follow: GhostFollow (i%)
        END SELECT
      END IF
    END IF
  END IF
NEXT

END SUB

SUB MoveInit (i AS INTEGER)
SHARED Ghost() AS GhostType

CONST left = ScrX + ScrLen / 2 - 95, right = ScrX + ScrLen / 2 + 65
CONST top = ScrY + ScrLen / 2 - 63, bot = ScrY + ScrLen / 2 + 33
CONST CenterX = ScrX + ScrLen / 2 - 15

IF Ghost(i).x = Ghost(i).LastX AND Ghost(i).y = Ghost(i).LastY AND Ghost(i).y <> FNInitPos%("y", i) AND Ghost(i).x <> FNInitPos%("x", i) THEN Ghost(i).ThinkWith = Follow

REM Moves Ghost from the top of the ghost-box to Pacman's initial location.
'IF Movement%((Ghost(i).x - (ScrX - 15)) / 16, (Ghost(i).y - (ScrY - 15)) / 16) = 0 THEN
  IF (Ghost(i).x = left OR Ghost(i).x = right) AND Ghost(i).y >= top AND Ghost(i).y < bot THEN Ghost(i).AddY = 16: Ghost(i).AddX = 0
  IF i = 2 OR i = 3 THEN
    IF Ghost(i).x < right AND Ghost(i).x >= CenterX AND Ghost(i).y = top THEN Ghost(i).AddX = 16: Ghost(i).AddY = 0
    IF Ghost(i).x <= right AND Ghost(i).x > CenterX AND Ghost(i).y = bot THEN Ghost(i).AddX = -16: Ghost(i).AddY = 0
  ELSE
    IF Ghost(i).x > left AND Ghost(i).x <= CenterX AND Ghost(i).y = top THEN Ghost(i).AddX = -16: Ghost(i).AddY = 0
    IF Ghost(i).x >= left AND Ghost(i).x < CenterX AND Ghost(i).y = bot THEN Ghost(i).AddX = 16: Ghost(i).AddY = 0
  END IF
'ELSE
'  Ghost(i).ThinkWith = Follow
'END IF
'----------------------------------------------------------------------------
IF Ghost(i).x = CenterX THEN
  IF Ghost(i).y = top AND i <> 2 THEN
    REM 50% chance of assigning Think to ThinkWith.  It Think is left as Init
    REM it will oventually be assigned Follow.
    Ghost(i).ThinkWith = FNFifty%(Init, Think)
    REM redraws the top of the ghost box.
    x1% = ScrX + ScrLen / 2 - 16: y1% = ScrY + ScrLen / 2 - 32
    LINE (x1%, y1%)-(x1% + 32, y1% + 16), 15, B
  ELSEIF Ghost(i).y = bot THEN
    Ghost(i).ThinkWith = Follow 'FNFifty%(Think, Follow)
  END IF
END IF

MoveGhost (i)
END SUB

SUB MovePac
SHARED HoldX%, HoldY%, Secret%, Scrn%()

REM Variables used for PacMan's last position.
HoldX% = x%: HoldY% = y%
 
IF Scrn%((x% - ScrX + AddX1%) / 16, (y% - ScrY + AddY1%) / 16) <> Wall THEN AddX% = AddX1%: AddY% = AddY1%
y% = y% + AddY%: x% = x% + AddX%

SELECT CASE Scrn%((x% - ScrX) / 16, (y% - ScrY) / 16)
  CASE IS = Wall
    REM Prevents Pacman from traveling through an obstruction.
    y% = y% - AddY%: x% = x% - AddX%
    DrawPacMan
    AddX% = 0: AddY% = 0
  CASE IS = -2
    Secret% = 3
    NextStage
  CASE IS = -3
    Secret% = 8
    NextStage
END SELECT

IF HoldX% <> x% OR HoldY% <> y% THEN
  REM The LINE erases the last place PacMan was in.
  'LINE (HoldX% - 14, HoldY% - 14)-(HoldX% + 14, HoldY% + 14), 0, BF
  'CALL Remain(HoldX% - 15, HoldY% - 15, (AddX%), (AddY%))

  REM tunnel Movement%s
  Tunnel% = FNAtEdge%(x%, y%, AddX%, AddY%)
  SELECT CASE Tunnel%
    CASE GoThruX
      CALL AddMove(x%, y%)
      x% = 2 * ScrX + ScrLen - x%
      CALL AddMove(x%, y%)
      x% = x% + AddX%
    CASE GoThruY
      CALL AddMove(x%, y%)
      y% = 2 * ScrY + ScrLen - y%
      CALL AddMove(x%, y%)
      y% = y% + AddY%
    CASE DeadEnd
      x% = x% - AddX%: y% = y% - AddY%
  END SELECT

  REM When Tunnel% = DeadEnd, PacMan's position has not changed.
  IF Tunnel% <> DeadEnd THEN CALL AddMove(HoldX%, HoldY%)
 
  DrawPacMan
  
  GetPellet
END IF

END SUB

SUB MovePrize
SHARED Fx%, Fy%, Fruit$, FruitTime!, AddFx%, AddFy%, LastFx%, LastFy%
SHARED GetFruit%, PrizeMask&(), Prize&(), Scrn%()

IF LastFx% <> Fx% OR LastFy% <> Fy% THEN
  PUT (LastFx% - 14, LastFy% - 14), PrizeMask&, AND
  CALL Remain(LastFx% - 15, LastFy% - 15, (AddFx%), (AddFy%))
  PUT (Fx% - 14, Fy% - 14), PrizeMask&, AND
  PUT (Fx% - 14, Fy% - 14), Prize&, OR
END IF

IF AddX% = -AddFx% AND AddX% <> 0 THEN
  OffSetX% = 32
ELSE
  OffSetX% = 16
END IF
IF AddY% = -AddFy% AND AddFy% <> 0 THEN
  OffSetY% = 32
ELSE
  OffSetY% = 16
END IF

FOR x1% = -OffSetX% TO OffSetX% STEP 16
  IF x% + x1% = Fx% THEN
    EatFruit$ = "t"
    EXIT FOR
  END IF
NEXT

IF EatFruit$ = "t" THEN
  EatFruit$ = ""
  FOR y1% = -OffSetY% TO OffSetY% STEP 16
    IF y% + y1% = Fy% THEN
      EatFruit$ = "t"
      EXIT FOR
    END IF
  NEXT
END IF

REM If PacMan gets the fruit.
IF EatFruit$ <> "" THEN
  IF Fruit$ = "t" THEN
    GetFruit% = RND * (Pellets% - 10) + 10
    Fruit$ = "a"
    Points (100 * INT((Stage% + 1) / 2))
  ELSE
    Points (200 * INT((Stage% + 1) / 2))
  END IF
  IF Fruit$ = "l" THEN Fruit$ = "f"
  LINE (Fx% - 13, Fy% - 14)-(Fx% + 15, Fy% + 14), 0, BF
  CALL Remain(LastFx% - 15, LastFy% - 15, (AddFx%), (AddFy%))
  EXIT SUB
END IF

REM When time run out to get the fruit.
IF TIMER - FruitTime! >= 6 THEN
  Fruit$ = "f"
  LINE (Fx% - 13, Fy% - 14)-(Fx% + 15, Fy% + 14), 0, BF
  CALL Remain(LastFx% - 15, LastFy% - 15, (AddFx%), (AddFy%))
END IF

REM Conditions to change to using another direction
IF Fx% > ScrX AND Fx% < ScrX + ScrLen AND Fy% > ScrY AND Fy% < ScrY + ScrLen THEN
  REM if the next position is a Wall
  IF Scrn%((Fx% - ScrX + AddFx%) / 16, (Fy% - ScrY + AddFy%) / 16) = Wall THEN NewMove% = true
  REM if the prize can go in a direction perpindicular to its current direction
  IF Scrn%((Fx% - ScrX + AddFy%) / 16, (Fy% - ScrY + AddFx%) / 16) <> Wall OR Scrn%((Fx% - ScrX - AddFy%) / 16, (Fy% - ScrY - AddFx%) / 16) <> Wall THEN NewMove% = true
END IF

IF NewMove% = true THEN
  DO
    Move% = RND * 4
   
    SELECT CASE Move%
     CASE 0
       AddFx% = 16: AddFy% = 0
     CASE 1
       AddFx% = -16: AddFy% = 0
     CASE 2
       AddFx% = 0: AddFy% = 16
     CASE 3
       AddFx% = 0: AddFy% = -16
    END SELECT
  LOOP UNTIL Scrn%((Fx% - ScrX + AddFx%) / 16, (Fy% - ScrY + AddFy%) / 16) <> Wall
END IF

LastFx% = Fx%: LastFy% = Fy%

REM tunnel Movement%s
SELECT CASE FNAtEdge%(Fx%, Fy%, AddFx%, AddFy%)
  CASE GoThruX
    Fx% = 2 * ScrX + ScrLen - Fx%
    Fx% = Fx% + AddFx%
  CASE GoThruY
    Fy% = 2 * ScrY + ScrLen - Fy%
    Fy% = Fy% + AddFy%
  CASE false
    Fx% = Fx% + AddFx%: Fy% = Fy% + AddFy%
END SELECT

END SUB

SUB NextFruit
SHARED PrizeX%, PrizeY%, NoPrize%, LastX%, LastY%, Prize&(), PrizeMask&()
SHARED Ghost() AS GhostType

REM 1 has not yet been added to Stage% when this SUB is called.

ON ERROR GOTO FruitError

REM Loads the file for the next fruit
SELECT CASE Stage%
  CASE IS <= 92
    FruitFile$ = "Prize" + FNStr$(INT((Stage% + 1) / 2))
   
    DEF SEG = VARSEG(Prize&(0))
    BLOAD path$ + FruitFile$ + ".GRH", VARPTR(Prize&(0))
  CASE 93, 94
    GET (Ghost(4).x, Ghost(4).y)-(Ghost(4).x + 28, Ghost(4).y + 28), Prize&
  CASE 95, 96
    GET (Ghost(3).x, Ghost(3).y)-(Ghost(3).x + 28, Ghost(3).y + 28), Prize&
  CASE 97, 98
    GET (Ghost(1).x, Ghost(1).y)-(Ghost(1).x + 28, Ghost(1).y + 28), Prize&
  CASE 99, 100
    GET (Ghost(2).x, Ghost(2).y)-(Ghost(2).x + 28, Ghost(2).y + 28), Prize&
END SELECT
  
REM Puts fruit on the screen then determines the position for the next fruit.
IF NoPrize% = true THEN
  PrizeX% = LastX%: PrizeY% = LastY%
  NoPrize% = false
END IF

PUT (PrizeX%, PrizeY%), Prize&, PSET
CALL MakeMask(PrizeMask&(), PrizeX%, PrizeY%, PrizeX% + 28, PrizeY% + 28)
LastX% = PrizeX%: LastY% = PrizeY%

REM This nest of IF statements determines the next location of the fruit.
REM I remarked it well since it is confusing.
IF PrizeY% = ScrLen + ScrY + 1 THEN
  REM This moves the fruit to the right after it has filled up the left and
  REM right sides of the screen.
  PrizeX% = PrizeX% + 28
 
  IF PrizeX% > ScrX + ScrLen THEN
    REM reinitialize their position because the fruit used of every position.
    PrizeX% = ScrX + ScrLen + 1: PrizeY% = ScrY + ScrLen - 28
  END IF
ELSE
  REM moves the fruit up
  PrizeY% = PrizeY% - 28
 
  IF PrizeY% < ScrY THEN
    REM moves the fruit to the right once space and back down to the bottom
    REM when it reaches the top of the screen
    PrizeY% = ScrY + ScrLen - 28
    PrizeX% = PrizeX% + 28
   
    REM This puts the fruit on the left side of the screen after it fills up
    REM the right side of the screen.
    IF PrizeX% > 640 - 28 THEN PrizeX% = ScrX MOD 28 + 28
   
    IF PrizeX% + 14 >= ScrX AND PrizeX% < ScrX + ScrLen THEN
      REM After the fruit fills up the left side of the screen it is put
      REM under the screen.
      PrizeY% = ScrY + ScrLen + 1
      PrizeX% = PrizeX% - 14
    END IF
   
  END IF
END IF

ON ERROR GOTO ErrorKiller
END SUB

SUB NextStage
DIM x1 AS INTEGER, y1 AS INTEGER
SHARED PlaceNum%, Difficulty%, Fruit$, HoldX%, HoldY%, Movement%()
SHARED SecretStage%, max%, UnSec%, PowerOn%, Secret%, EyeTrail%(), Scrn%()
SHARED Ghost() AS GhostType

REM The "blue ghost effect" wears off when GhostCount% = 70.  Setting the
REM GhostCount% = 69 ensures that it will become 70 and turn the "blue ghost
REM effect" off at the begining of the new stage.
PowerOn% = true: GhostCount% = GhostLimit%

REM Moves the pacman and ghost back to their original positions.
x% = CenterX: y% = CenterY + 48
HoldX% = x%: HoldY% = y%
AddX1% = 0: AddY1% = 0
AddX% = 0: AddY% = 0
FOR i% = 1 TO 4
  Ghost(i%).x = FNInitPos%("x", i%)
  Ghost(i%).y = FNInitPos%("y", i%)
  Ghost(i%).Status = Normal
  Ghost(i%).ThinkWith = Init
  Ghost(i%).Trail = MaxInt
NEXT
ERASE EyeTrail%
ERASE Movement%
PlaceNum% = 0
Pellets% = 0
Scrn%(13, 16) = Pellet
'----------------------------------------------------------------------------
REM The line eraces the baord.  Since I do not clear the whole screen I do not
REM need to redraw the fruits or score.
LINE (ScrX, ScrY)-(ScrX + ScrLen, ScrY + ScrLen), 0, BF
'----------------------------------------------------------------------------
IF Secret% <> 0 THEN
  SELECT CASE Stage%
    CASE 3
      IF SecretStage% = 2 THEN UnSec% = true
      IF SecretStage% = 1 THEN
        SecretStage% = 2
      ELSE
        SecretStage% = 1
      END IF
    CASE 8
      IF SecretStage% = 4 THEN UnSec% = true
      IF SecretStage% = 3 THEN
        SecretStage% = 4
      ELSE
        SecretStage% = 3
      END IF
    CASE 90
      IF SecretStage% = 6 THEN UnSec% = true
      IF SecretStage% = 5 THEN
        SecretStage% = 6
      ELSE
        SecretStage% = 5
      END IF
  END SELECT
  IF UnSec% = true THEN
    SecretStage% = 0
    Secret% = 0
    LOCATE FNTextY%(ScrY) - 1, FNTextX%(CenterX) - 7
    PRINT SPC(14);
    UnSec% = false
  END IF
END IF

IF Secret% <> 0 THEN
  Fruit$ = "f"

  S1$ = "Sec" + FNStr$(SecretStage%) + "_1.GRH"
  S2$ = "Sec" + FNStr$(SecretStage%) + "_2.GRH"
ELSE
  Fruit$ = ""
 
  Stage% = Stage% + 1
  IF Stage% > max% THEN max% = Stage%

  SELECT CASE Stage%
  CASE IS = 15
    S3$ = FNStr$(RND * 13 + 1)
    S1$ = "Scr" + S3$ + "_1.GRH"
    S2$ = "Scr" + S3$ + "_2.GRH"
  CASE ELSE
    S1$ = "Scr" + FNStr$(Stage%) + "_1.GRH"
    S2$ = "Scr" + FNStr$(Stage%) + "_2.GRH"
  END SELECT

  NextFruit
END IF
'----------------------------------------------------------------------------
IF Stage% = 97 OR Stage% = 100 OR Stage% = 88 THEN
  FOR a% = 11 TO 15 STEP 2
    Scrn%(a%, 13) = Pellet
  NEXT
END IF

IF Stage% = 98 THEN
  Scrn%(11, 13) = Pellet
  Scrn%(15, 13) = Pellet
END IF
'----------------------------------------------------------------------------
CALL SetStage(S1$, S2$)

END SUB

SUB Pause
DIM counter AS INTEGER, x1 AS INTEGER, y1 AS INTEGER
  stopClock (-1)
  x1 = FNInitPos%("x", 1): y1 = FNInitPos%("y", 1)
    
  FOR add% = 0 TO 8 STEP 4
    LINE (x1 + add%, y1 + add%)-(x1 + 94 - add%, y1 + 30 - add%), add% + 3, BF
  NEXT
     
  LOCATE 15, 40
  PRINT "F2"
  LOCATE 16, 38
  PRINT "Pause!"
    
  DO
    IF counter = 1 THEN
      FOR add% = 0 TO 8 STEP 4
        LINE (x1 + add%, y1 + add%)-(x1 + 94 - add%, y1 + 30 - add%), add% + 3, BF
      NEXT
    ELSE
      LOCATE 15, 40
      PRINT "F2"
      LOCATE 16, 38
      PRINT "Pause!"
    END IF
    REM Alternates counter between 0 and 1
    counter = (counter + 1) MOD 2
    SLEEP 1
  LOOP UNTIL INKEY$ <> ""
 
  LINE (x1, y1)-(x1 + 94, y1 + 30), 0, BF
  stopClock (1)
END SUB

SUB PelletCounter
SHARED GhostKill%, PowerOn%, Ghost() AS GhostType

REM Makes the power pellet wear off.
IF PowerOn% = true THEN
  GhostCount% = GhostCount% + 1
  AllNorm% = true
  FOR i% = 1 TO 4
    IF Ghost(i%).Status <> Normal THEN AllNorm% = false
  NEXT

  REM This is when the power pellet wears off.
  IF GhostCount% >= GhostLimit% OR AllNorm% = true THEN
    PowerOn% = false
    FOR i% = 1 TO 4
      IF Ghost(i%).Status = Blue THEN Ghost(i%).Status = Normal
    NEXT
    GhostCount% = 0
    GhostLimit% = 0
  END IF
ELSE
  REM Makes the points for killing ghosts start over when the power pellet
  REM wears off and none of the ghosts are eyes.
  IF Ghost(2).Status <> Eyes AND Ghost(4).Status <> Eyes AND Ghost(3).Status <> Eyes AND Ghost(1).Status <> Eyes THEN GhostKill% = 0
END IF
END SUB

SUB Points (num%)
SHARED Difficulty%, Mute%
stopClock (-1)

num$ = FNStr$(num%)

IF Difficulty% = Easy THEN
  L% = 3
  WHILE L% < LEN(num$)
    num$ = LEFT$(num$, LEN(num$) - L%) + "," + RIGHT$(num$, L%)
    L% = L% + 4
  WEND
END IF

left% = 8 * INT(x% / 8 - 1)
top% = 16 * INT(y% / 16 - 1)
right% = left% + LEN(num$) * 8

DIM Pts&(FNSize&(right% - left% + 1, 16))
GET (left%, top%)-(right%, top% + 15), Pts&

LOCATE top% / 16 + 1, left% / 8 + 1
COLOR 10
PRINT num$
COLOR 15

Score& = Score& + num%
s% = LOG(num% / 100) / LOG(2)
IF Mute% = false THEN
  FOR num% = 1 TO 4
    SOUND 500 + 100 * s% / 3 - num% * 110, 1
    SOUND 200 + 100 * s% / 2 + num% * 10, 1
  NEXT
ELSE
  Time! = TIMER
  WHILE TIMER - Time! < .4: WEND
END IF

PUT (left%, top%), Pts&, PSET

stopClock (1)
END SUB

SUB PrintAttr (Attrib%)
SHARED Secret%, SecretStage%, RankPlace%

DIM OutPut$

SELECT CASE Attrib%
  CASE TheStage
    IF Secret% = 0 THEN
      REM I use STR$ and not FNStr$ because I want the space STR$ adds at
      REM the front of the string.
      OutPut$ = "Stage" + STR$(Stage%)
    ELSE
      OutPut$ = "Stage Secret" + STR$(SecretStage%)
    END IF
    LOCATE RowAboveScr, FNTextX%(CenterX) - LEN(OutPut$) / 2
 
  CASE TheLives
    OutPut$ = "Lives x" + STR$(Lives%)
    LOCATE RowAboveScr, FNTextX%(ScrX + ScrLen) - LEN(OutPut$)
 
  CASE TheScore
    OutPut$ = FNStr$(Score&)
    LOCATE RowAboveScr, FNTextX%(ScrX)
 
  CASE TheRank
    IF RankPlace% >= 20 THEN EXIT SUB
    IF RankPlace% = 0 THEN
      OutPut$ = "Hi-Score"
    ELSE
      OutPut$ = FNStr$(RankPlace% + 1) + " "
    END IF
    LOCATE RowAboveScr - 1, FNTextX%(ScrX)
  
END SELECT

PRINT OutPut$
END SUB

SUB PutFruit
SHARED FruitTime!, Fruit$, Fx%, Fy%, LastFx%, LastFy%
REM Sub that puts a Prize under the ghostbox once per stage.

SELECT CASE Fruit$
  CASE "a": Fruit$ = "l"
  CASE "": Fruit$ = "t"
END SELECT

Fx% = CenterX: Fy% = CenterY + 48
LastFx% = Fx%: LastFy% = Fy%

FruitTime! = TIMER
END SUB

SUB Remain (gx%, gy%, ax%, ay%)
SHARED Difficulty%, Scrn%()
ax% = ABS(ax%): ay% = ABS(ay%)
      
REM Puts any pellets or power pellets pinky erased by going over them back.
FOR Gy1% = gy% - (16 + ay%) TO gy% + ay% STEP 16
FOR Gx1% = gx% - (16 + ax%) TO gx% + ax% STEP 16
 IF (Gx1% - (ScrX - 15)) / 16 >= 0 AND (Gx1% - (ScrX - 15)) / 16 <= 26 AND (Gy1% - (ScrY - 15)) / 16 >= 0 AND (Gy1% - (ScrY - 15)) / 16 <= 26 THEN
   IF Scrn%((Gx1% - (ScrX - 15)) / 16, (Gy1% - (ScrY - 15)) / 16) = Pellet THEN
    IF Difficulty% = Easy THEN
      LINE (Gx1% + 13, Gy1% + 13)-(Gx1% + 17, Gy1% + 17), DotColor, BF
    ELSE
      CIRCLE (Gx1% + 16, Gy1% + 16), 3, DotColor
      PAINT (Gx1% + 17, Gy1% + 17), DotColor
    END IF
   END IF
 END IF
NEXT: NEXT
END SUB

SUB SetStage (S1$, S2$)
SHARED slowing!, PowColor%, pacr2&(), Ghost() AS GhostType
SHARED InkySprite&(), DinkySprite&(), SueSprite&(), PinkySprite&(), BlueGhost&()

DIM Scr(FNSize&(ScrLen, ScrLen / 2))

REM This is one of the last SUBs I made in this game.  It is an attempt to
REM cut down on redundancies by putting in this SUB what happens both at the
REM beginning of the game and at every level change.

PrintAttr (TheStage)

SlowGhost! = slowing! - (Stage% * .0007)

FOR i% = 1 TO 4
  Ghost(i%).LastX = Ghost(i%).x
  Ghost(i%).LastY = Ghost(i%).y
NEXT
'----------------------------------------------------------------------------
REM Loads a new Screen.
DEF SEG = VARSEG(Scr(0))
BLOAD path$ + S1$, VARPTR(Scr(0))
PUT (ScrX, ScrY), Scr

DEF SEG = VARSEG(Scr(0))
BLOAD path$ + S2$, VARPTR(Scr(0))
PUT (ScrX, ScrY + ScrLen / 2 + 1), Scr
'----------------------------------------------------------------------------
PowColor% = FNGetPowColor%

REM draws the power pellets
REM The real drawing of the power pellets is done in MainOperations.  This is
REM just here so the figure screen SUB the power pellets are there.
FOR x5% = ScrX + 32 TO ScrX + ScrLen - 32 STEP ScrLen - 64
FOR y5% = ScrY + 32 TO ScrY + ScrLen - 64 STEP ScrLen - 112
  CIRCLE (x5%, y5%), 6, 15
  PAINT (x5%, y5%), 15
NEXT: NEXT

FigureScreen

REM This redraws the white power pellets as their color for this level.
FOR x5% = ScrX + 32 TO ScrX + ScrLen - 32 STEP ScrLen - 64
FOR y5% = ScrY + 32 TO ScrY + ScrLen - 64 STEP ScrLen - 112
  CIRCLE (x5%, y5%), 6, PowColor%
  PAINT (x5%, y5%), PowColor%
NEXT: NEXT
'----------------------------------------------------------------------------
REM  The Black Box Eraces the Screen
c% = FNGetBlueGhostColor%

PUT (Ghost(2).x, Ghost(2).y), InkySprite&, PSET
PUT (Ghost(1).x, Ghost(1).y), PinkySprite&, PSET
PUT (Ghost(3).x, Ghost(3).y), DinkySprite&, PSET
PUT (Ghost(4).x, Ghost(4).y), SueSprite&, PSET

IF Difficulty% = Hard OR (Difficulty% = Normal AND c2% <> 9) OR (Difficulty% = Easy AND c% <> 11) OR Stage% = 1 THEN
  REM The Blue-Ghost(When PacMan has a power pellet).
  x1 = FNInitPos%("x", 1): y1 = FNInitPos%("y", 1)
  FOR Gx1% = x1 TO x1 + 28
    FOR Gy1% = y1 TO y1 + 28
      IF POINT(Gx1%, Gy1%) = 13 THEN PSET (Gx1%, Gy1%), c%
    NEXT
  NEXT

  GET (x1, y1)-(x1 + 28, y1 + 28), BlueGhost&
  LINE (x1, y1)-(x1 + 28, y1 + 28), 0, BF
  PUT (x1, y1), PinkySprite&
END IF
'----------------------------------------------------------------------------
DIM Pts&(FNSize&(48, 16))
GET (CenterX - 24, CenterY + 48)-(CenterX + 23, CenterY + 63), Pts&
LOCATE 19, FNTextX%(CenterX) - 3
COLOR 14
PRINT "READY!"
COLOR 15

SLEEP

PUT (CenterX - 24, CenterY + 48), Pts&, PSET
PUT (x% - 14, y% - 14), pacr2&, PSET

GetPellet

Ghost(1).Delay = TIMER + 4
Ghost(2).Delay = TIMER + 1
Ghost(3).Delay = TIMER + 3
Ghost(4).Delay = TIMER + 2
END SUB

SUB stopClock (j%)
  SHARED Ghost() AS GhostType

  REM If j% is -1 then it reduces they delay to the ammount of seconds the
  REM delay is.  If j% is 1 then it adds the time back into the delay.  The
  REM purpose of this SUB is to make things like pauseing the game or
  REM operations that take a long time (relatively) not mess up the delay of
  REM the ghosts.
 
  FOR i% = 1 TO 4
    Ghost(i%).Delay = Ghost(i%).Delay + j% * TIMER
  NEXT
  FruitTime! = FruitTime! + j% * TIMER
END SUB

SUB Won
SHARED HiScores&(), HiScores$()
'Stage% = HiScore
HiScore

CLS
COLOR 14
LOCATE 9, 31

IF RankPlace% < 20 AND HiScores$(RankPlace% + 1) <> "" THEN
  p$ = "CONGRATULATIONS " + HiScores$(RankPlace% + 1) + "!"
  LOCATE 9, 40 - LEN(p$) / 2
  PRINT p$
ELSE
  PRINT "CONGRATULATIONS!"
END IF

SLEEP 1
COLOR 9

p$ = "Game By:  Jimmy Reumuth"
LOCATE 11, 40 - LEN(p$) / 2: PRINT p$
SLEEP 1

p$ = "Janurary 2, 1996 - October 22, 1997 (sporadically)"
LOCATE 13, 40 - LEN(p$) / 2: PRINT p$
SLEEP 1

COLOR 12
p$ = "Special Thanks to:"
LOCATE 15, 40 - LEN(p$) / 2: PRINT p$
SLEEP 1

p$ = "Mike Tabone"
LOCATE 17, 40 - LEN(p$) / 2: PRINT p$
SLEEP 1

p$ = "Joseph Saenz"
LOCATE 19, 40 - LEN(p$) / 2: PRINT p$
SLEEP 1

p$ = "and Mr. Jackson!!!"
LOCATE 21, 40 - LEN(p$) / 2: PRINT p$
SLEEP 1

SLEEP: SYSTEM
END SUB

